import { Service } from '../../../core/Service';
import { GEAbschlussFaecher } from '../../../core/data/abschluss/GEAbschlussFaecher';
import { AbschlussErgebnis } from '../../../core/data/abschluss/AbschlussErgebnis';
export declare class ServicePrognose extends Service<GEAbschlussFaecher, AbschlussErgebnis> {
    constructor();
    /**
     * Prüft, ob Lernbereichsnoten bei den Sbchlussfächern zur Verfügung stehen oder nicht.
     *
     * @param faecher   die Abschlussfächer
     *
     * @return true, falls die Lernbereichsnoten vorhanden sind, ansonsten false
     */
    private static hatLernbereichsnoten;
    /**
     * Führt die Prognoseberechnung anhand der übergebenen Abschlussfächer durch
     * und gibt das Berechnungsergebnis zurück.
     *
     * @param input    die Abschlussfächer
     *
     * @return das Ergebnis der Prognoseberechnung
     */
    handle(input: GEAbschlussFaecher): AbschlussErgebnis;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_abschluss_ge_ServicePrognose(obj: unknown): ServicePrognose;
