import { JavaObject } from '../../../java/lang/JavaObject';
import { GostBelegpruefungsArt } from '../../../core/abschluss/gost/GostBelegpruefungsArt';
import { GostBelegungsfehler } from '../../../core/abschluss/gost/GostBelegungsfehler';
export declare class GostBelegpruefungErgebnisFehler extends JavaObject {
    code: String;
    art: String;
    beschreibung: String;
    /**
     * Erzeugt eine neue Instanz eines Fehlers beim Ergebnis der Belegprüfung.
     *
     * @param f           der Typ des Belegungsfehlers (siehe {@link GostBelegungsfehler})
     * @param pruef_art   die Art der durchgeführtern Belegungprüfung (siehe {@link GostBelegpruefungsArt}), um
     *                    die konkrete Ausprägung des Textinformationen bestimmen zu können.
     */
    constructor(f: GostBelegungsfehler, pruef_art: GostBelegpruefungsArt);
    /**
     * Erzeugt eine neue Instanz eines Fehlers beim Ergebnis der Belegprüfung.
     * Dieser Konstruktor dient als Default-Konstruktor für die Serialisierung / Deserialisierung
     * aus JSON-Dateien.
     */
    constructor();
    isTranspiledInstanceOf(name: string): boolean;
    static transpilerFromJSON(json: string): GostBelegpruefungErgebnisFehler;
    static transpilerToJSON(obj: GostBelegpruefungErgebnisFehler): string;
    static transpilerToJSONPatch(obj: Partial<GostBelegpruefungErgebnisFehler>): string;
}
export declare function cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegpruefungErgebnisFehler(obj: unknown): GostBelegpruefungErgebnisFehler;
