import { JavaObject } from '../../../java/lang/JavaObject';
export declare class GostBelegpruefungsArt extends JavaObject {
    static readonly EF1: GostBelegpruefungsArt;
    static readonly GESAMT: GostBelegpruefungsArt;
    readonly kuerzel: String;
    readonly beschreibung: String;
    /**
     * Erzeugt ein neues Abitur-Belegungsart-Objekt
     *
     * @param kuerzel        das der Kurs-Belegungsart
     * @param beschreibung   die textuelle Beschreibung der Kurs-Belegungsart
     */
    private constructor();
    /**
     * Gibt die Art der Belegprüfung anhand des übergebenen Kürzels zurück.
     *
     * @param kuerzel    das Kürzel der Art der Belegprüfung
     *
     * @return die Art der Belegprüfung
     */
    static fromKuerzel(kuerzel: String | null): GostBelegpruefungsArt | null;
    toString(): String;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegpruefungsArt(obj: unknown): GostBelegpruefungsArt;
