"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehler = exports.GostBelegungsfehler = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const GostBelegpruefungsArt_1 = require("../../../core/abschluss/gost/GostBelegpruefungsArt");
const GostBelegungsfehlerArt_1 = require("../../../core/abschluss/gost/GostBelegungsfehlerArt");
class GostBelegungsfehler extends JavaObject_1.JavaObject {
    static ABI_10 = new GostBelegungsfehler("ABI_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Unter den vier Abiturfächern müssen zwei der Fächer Deutsch, Mathematik oder Fremdsprache sein.", null);
    static ABI_11 = new GostBelegungsfehler("ABI_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Religionslehre und Sport dürfen nicht gleichzeitig Abiturfächer sein.", null);
    static ABI_12 = new GostBelegungsfehler("ABI_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "In Q2.2 muss das 3. Abiturfach schriftlich belegt sein.", null);
    static ABI_13 = new GostBelegungsfehler("ABI_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "In Q2.2 muss das 4. Abiturfach mündlich belegt sein.", null);
    static ABI_15 = new GostBelegungsfehler("ABI_15", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Sport kann nur als 2. oder als 4. Abiturfach gewählt werden.", null);
    static ABI_16 = new GostBelegungsfehler("ABI_16", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Fächer, die keine Abiturfächer sind, müssen in Q2.2 mündlich belegt werden.", null);
    static ABI_17 = new GostBelegungsfehler("ABI_17", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Das 3. Abiturfach muss von Q1.1 bis Q2.2 schriftlich belegt sein.", null);
    static ABI_18 = new GostBelegungsfehler("ABI_18", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Das 4. Abiturfach muss von Q1.1 bis Q2.1 schriftlich belegt sein.", null);
    static ABI_19 = new GostBelegungsfehler("ABI_19", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Unter den vier Abiturfächern müssen zwei der Fächer Deutsch, Mathematik oder Fremdsprache sein. Dies kann nicht durch zwei Fremdsprachen erfüllt werden.", null);
    static ABI_21 = new GostBelegungsfehler("ABI_21", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es kann nur ein Fach 1. Abiturfach sein.", null);
    static ABI_22 = new GostBelegungsfehler("ABI_22", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es kann nur ein Fach 2. Abiturfach sein.", null);
    static ABI_23 = new GostBelegungsfehler("ABI_23", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es kann nur ein Fach 3. Abiturfach sein.", null);
    static ABI_24 = new GostBelegungsfehler("ABI_24", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es kann nur ein Fach 4. Abiturfach sein.", null);
    static ANZ_10 = new GostBelegungsfehler("ANZ_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Einführungsphase müssen in jedem Halbjahr mindestens 10 Fächer belegt werden. Vertiefungskurse werden bei der Zählung nicht berücksichtigt.", "In EF.1 müssen mindestens 10 Kurse belegt werden. Bei der Kurszählung werden Vertiefungskurse nicht mitgezählt.");
    static ANZ_11_INFO = new GostBelegungsfehler("ANZ_11_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Die Stundenbandbreite sollte pro Halbjahr 32 bis 36 Stunden betragen, um eine gleichmäßige Stundenbelastung zu gewährleisten.", "Die Gesamtstundenzahl sollte 32 bis 36 Stunden betragen, um eine gleichmäßige Stundenbelastung in der Oberstufe zu gewährleisten.");
    static ANZ_12 = new GostBelegungsfehler("ANZ_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase müssen mindestens 38 anrechenbare Kurse belegt werden.", null);
    static ANZ_13 = new GostBelegungsfehler("ANZ_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase müssen mindestens 32 anrechenbare Kurse belegt werden.", null);
    static BIL_4_INFO = new GostBelegungsfehler("BIL_4_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Programmfehler: Dieser Hinweis ist für eine Gesamtbelegprüfung der Sek II nicht vorgesehen!", "Soll ein bilinguales Sachfach zum Sprachenschwerpunkt beitragen, so muss es schriftlich belegt werden.");
    static BIL_10 = new GostBelegungsfehler("BIL_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Im bilingualen Bildungsgang muss die bilinguale Fremdsprache in EF.1 und EF.2 schriftlich und in Q1.1 bis Q2.2 als Leistungskurs belegt werden.", "Im bilingualen Bildungsgang muss die bilinguale Fremdsprache schriftlich belegt werden.");
    static BIL_11_INFO = new GostBelegungsfehler("BIL_11_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Im bilingualen Bildungsgang werden in EF.1 und EF.2 in der Regel zwei bilinguale Sachfächer belegt.", "Im bilingualen Bildungsgang sollten zwei bilinguale Sachfächer belegt werden.");
    static BIL_12 = new GostBelegungsfehler("BIL_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Im bilingualen Bildungsgang muss ein bilinguales Sachfach durchgehend von Q1.1 bis Q2.1 schriftlich belegt werden.", null);
    static BIL_13 = new GostBelegungsfehler("BIL_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ein bilinguales Sachfach muss unter den Abiturfächern sein.", null);
    static BIL_14 = new GostBelegungsfehler("BIL_14", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es können nur bilinguale Sachfächer belegt werden, deren Sprache in der Sekundarstufe erlernt wurde.", "Es können nur bilinguale Sachfächer belegt werden, deren Sprache in der Sekundarstufe erlernt wurde.");
    static BIL_15 = new GostBelegungsfehler("BIL_15", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Im bilingualen Bildungsgang muss in EF.1 und EF.2 mindestens ein bilinguales Sachfach belegt werden.", "Im bilingualen Bildungsgang muss mindestens ein bilinguales Sachfach belegt werden.");
    static D_10 = new GostBelegungsfehler("D_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Deutsch muss von EF.1 bis Q2.2 belegt werden.", "Deutsch muss in EF.1 schriftlich belegt werden.");
    static D_11 = new GostBelegungsfehler("D_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Deutsch muss von EF.1 bis wenigstens Q2.1 schriftlich belegt werden.", "Deutsch muss in EF.1 schriftlich belegt werden.");
    static E1BEL_10 = new GostBelegungsfehler("E1BEL_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Bis auf Literatur, vokal- und instrumentalpraktische Kurse, Zusatzkurse, Vertiefungsfächer und Projektkurse können keine Fächer hinzugewählt werden, die nicht schon ab EF.1 belegt wurden.", null);
    static FS_10 = new GostBelegungsfehler("FS_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Mindestens eine Fremdsprache muss von EF.1 bis Q2.2 durchgehend belegt werden. Handelt es sich hierbei um eine neu einsetzende Fremdsprache, so muss zusätzlich mindestens eine aus der SI fortgeführte Fremdsprache von EF.1 bis EF.2 belegt werden.", "Da die gewählte Fremdsprache in der Oberstufe nicht durchgehend angeboten wird, muss entweder zusätzliche eine neu einsetzende Fremdsprache, oder eine andere in der Sekundarstufe I begonnene Fremdsprache belegt werden.");
    static FS_11 = new GostBelegungsfehler("FS_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Mindestens eine durchgehend belegte Fremdsprache muss von EF.1 bis Q2.1 schriftlich belegt sein.", "Mindestens eine Fremdsprache muss in EF.1 schriftlich belegt werden. Die zu wählende Fremdsprache muss durchgehend angeboten werden.");
    static FS_12 = new GostBelegungsfehler("FS_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "In EF.1 und EF.2 müssen alle gewählten Fremdsprachenfächer schriftlich belegt werden.", "In EF.1 müssen alle belegten Fremdsprachen schriftlich belegt werden.");
    static FS_13 = new GostBelegungsfehler("FS_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Bei unvollendeter 2. Fremdsprache, muss die in der Sekundarstufe 1 begonnene 2. Fremdsprache in EF schriftlich oder eine neu einsetzende Fremdsprache durchgehend schriftlich belegt werden.", "Wurde die 2. Fremdsprache erst ab Klasse 8 erlernt, muss die in der Sekundarstufe 1 begonnene 2. Fremdsprache oder eine neu einsetzende Fremdsprache schriftlich in EF.1 belegt werden.");
    static FS_14 = new GostBelegungsfehler("FS_14", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Bei fehlender 2. Fremdsprache muss eine neu einsetzende Fremdsprache durchgehend schriftlich belegt werden.", "Wurde bisher keine 2. Fremdsprache erlernt, muss eine neu einsetzende Fremdsprache in EF.1 schriftlich belegt werden.");
    static FS_15 = new GostBelegungsfehler("FS_15", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Kurse in neu einsetzenden Fremdsprachen müssen schriftlich belegt werden.", null);
    static FS_16 = new GostBelegungsfehler("FS_16", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Mindestens eine fortgeführte Fremdsprache muss in EF.1 und EF.2 schriftlich belegt werden.", "Mindestens eine in der Sekundarstufe I begonnene Fremdsprache muss in EF.1 schriftlich belegt werden.");
    static FS_17 = new GostBelegungsfehler("FS_17", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Neu einsetzende Fremdsprachen dürfen nicht als Leistungskurs belegt werden.", null);
    static FS_18 = new GostBelegungsfehler("FS_18", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Mindestens eine Fremdsprache muss von EF.1 bis Q2.2 belegt werden.", "Mindestens eine in der Sekundarstufe I begonnene Fremdsprache muss in EF.1 schriftlich belegt werden.");
    static FS_19_INFO = new GostBelegungsfehler("FS_19_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Eine erfolgreiche Feststellungsprüfung in der Muttersprache am Ende der Sekundarstufe I und am Ende von EF.2 ist notwendig, um die Fremdsprachenbedingungen zu erfüllen.", "Eine erfolgreiche Feststellungsprüfung in der Muttersprache am Ende der Sekundarstufe I und am Ende von EF.2 ist notwendig, um die Fremdsprachenbedingungen zu erfüllen.");
    static FS_20 = new GostBelegungsfehler("FS_20", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Eine neu einsetzende Fremdsprache kann nur gewählt werden, wenn diese nicht zuvor in der Sekundarstaufe I belegt wurde. Die Sprachenfolge ist fehlerhaft.", "Eine neu einsetzende Fremdsprache kann nur gewählt werden, wenn diese nicht zuvor in der Sekundarstaufe I belegt wurde. Die Sprachenfolge ist fehlerhaft.");
    static FS_21 = new GostBelegungsfehler("FS_21", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Eine fortgeführte Fremdsprache wurde in der Sprachenfolge als neu einsetzend eingetragen. Die Sprachenfolge ist fehlerhaft.", "Eine fortgeführte Fremdsprache wurde in der Sprachenfolge als neu einsetzend eingetragen. Die Sprachenfolge ist fehlerhaft.");
    static FS_22_INFO = new GostBelegungsfehler("FS_22_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Englisch wurde nicht in der Sprachenfolge eingetragen. Bitte Prüfen Sie die Sprachenfolge auf Korrektheit.", "Englisch wurde nicht in der Sprachenfolge eingetragen. Bitte Prüfen Sie die Sprachenfolge auf Korrektheit.");
    static FS_23 = new GostBelegungsfehler("FS_23", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es wird das Fach einer fortgeführten Fremdsprache belegt, zu dem es keine entsprechende Eintragung einer Belegung oder Sprachprüfung in der Sekundarstufe I gibt. Bitte die Sprachenfolge und Sprachprüfungen prüfen.", "Es wird das Fach einer fortgeführten Fremdsprache belegt, zu dem es keine entsprechende Eintragung einer Belegung oder Sprachprüfung in der Sekundarstufe I gibt. Bitte die Sprachenfolge und Sprachprüfungen prüfen.");
    static FS_24 = new GostBelegungsfehler("FS_24", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ist die Bedingungen für die Belegung einer zweiten Fremdsprache in der Sekundarstufe I noch nicht erfüllt worden, so müssen in der Einführungsphase zwei Fremdsprachen belegt werden.", "Ist die Bedingungen für die Belegung einer zweiten Fremdsprache in der Sekundarstufe I noch nicht erfüllt worden, so müssen in der Einführungsphase zwei Fremdsprachen belegt werden.");
    static FS_25 = new GostBelegungsfehler("FS_25", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es wurde keine fortführbare Fremdsprache in der Sprachbelegung gefunden. Bitte prüfen Sie die Sprachenfolge.", "Es wurde keine fortführbare Fremdsprache in der Sprachbelegung gefunden. Bitte prüfen Sie die Sprachenfolge.");
    static GE_1_INFO = new GostBelegungsfehler("GE_1_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Programmfehler: Dieser Hinweis ist für eine Gesamtbelegprüfung der Sek II nicht vorgesehen!", "Wird Geschichte nicht in EF.1 belegt, so muss Geschichte in der Qualifikationsphase als Zusatzkurs gewählt werden.");
    static GE_10 = new GostBelegungsfehler("GE_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Geschichte muss von EF.1 bis wenigstens Q1.2 oder als Zusatzkurs (in der Regel von Q2.1 bis Q2.2) belegt werden.", null);
    static GKS_10 = new GostBelegungsfehler("GKS_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase sind pro Halbjahr mindestens 7 Fächer in Grundkursen zu wählen.", null);
    static GKS_11 = new GostBelegungsfehler("GKS_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase sind pro Halbjahr mindestens 6 Fächer in Grundkursen zu wählen.", null);
    static GW_10 = new GostBelegungsfehler("GW_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Mindestens eine Gesellschaftswissenschaft muss von Q1.1 bis Q2.2 durchgehend belegt werden.", "Mindestens eine Gesellschaftswissenschaft muss in EF.1 belegt werden und durchgängig belegbar sein.");
    static GW_11 = new GostBelegungsfehler("GW_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "In EF.1 und EF.2 muss mindestens eine Gesellschaftswissenschaft schriftlich belegt sein.", "Mindestens eine Gesellschaftswissenschaft muss in EF.1 schriftlich belegt werden.");
    static GW_12 = new GostBelegungsfehler("GW_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Mindestens eine Gesellschaftswissenschaft oder Religionslehre muss von Q1.1 bis wenigstens Q2.1 schriftlich belegt werden.", null);
    static IGF_10 = new GostBelegungsfehler("IGF_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Inhaltsgleiche Fächer und Projektkurse dürfen in jedem Halbjahr nur einmal belegt werden.", "Inhaltsgleiche Fächer dürfen nur einmal belegt werden.");
    static KU_MU_10 = new GostBelegungsfehler("KU_MU_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Mindestens eines der Fächer Kunst oder Musik muss von EF.1 bis wenigstens Q1.2 durchgehend belegt werden. In der Qualifikationsphase kann auch alternativ Literatur, ein vokalpraktisches oder ein instrumentalpraktisches Fach mit zwei Kursen belegt werden.", "Mindestens eines der Fächer Kunst oder Musik muss in EF.1 belegt werden");
    static L_10_INFO = new GostBelegungsfehler("L_10_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Um das Latinum zu erlangen muss Latein in EF.1 und EF.2 belegt werden.", "Um das Latinum zu erlangen muss Latein in EF.1 schriftlich fortgeführt werden.");
    static L_11_INFO = new GostBelegungsfehler("L_11_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Um das Latinum zu erlangen muss Latein mindestens bis Q1.2, je nach Stundenvolumen sogar bis Q2.2 belegt werden.", null);
    static L_12_INFO = new GostBelegungsfehler("L_12_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Um das Latinum zu erlangen muss Latein mindestens bis EF.2, je nach Beginn und Stundenvolumen sogar bis Q2.2 belegt werden.", null);
    static LI_IV_10 = new GostBelegungsfehler("LI_IV_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Die Fächer Literatur, instrumentalpraktischer bzw. vokalpraktischer Grundkurs dürfen maximal in zwei aufeinanderfolgenden Halbjahren belegt werden.", null);
    static LI_IV_11 = new GostBelegungsfehler("LI_IV_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es darf nur eins der Fächer Literatur, IP oder VP belegt werden. (Schulen mit genehmigtem musisch-künstlerischem Schwerpunkt müssen betroffene Schüler in SchILD-NRW manuell zulassen).", null);
    static LK_10 = new GostBelegungsfehler("LK_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase müssen zwei Fächer durchgehend in Leistungskursen belegt werden.", null);
    static LK_11 = new GostBelegungsfehler("LK_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es dürfen nicht mehr als zwei Fächer als Leistungskurse belegt werden.", null);
    static LK1_10 = new GostBelegungsfehler("LK1_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Erstes Abiturfach nicht eindeutig identifizierbar.", null);
    static LK1_11 = new GostBelegungsfehler("LK1_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Das erste Leistungskursfach muss eine fortgeführte Fremdsprache, Mathematik, eine klassische Naturwissenschaft oder Deutsch sein.", null);
    static LK1_12 = new GostBelegungsfehler("LK1_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ist Deutsch erstes Leistungskursfach, muss Mathematik oder eine Fremdsprache unter den vier Abiturfächern sein.", null);
    static LK1_13 = new GostBelegungsfehler("LK1_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Die Abiturfächer müssen alle drei Aufgabenfelder abdecken. Insgesamt sind vier Abiturfächer zu belegen.", null);
    static M_10 = new GostBelegungsfehler("M_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Mathematik muss von EF.1 bis Q2.2 belegt werden.", "Mathematik muss in EF.1 schriftlich belegt werden.");
    static M_11 = new GostBelegungsfehler("M_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Mathematik muss von EF.1 bis wenigstens Q2.1 schriftlich belegt werden.", "Mathematik muss in EF.1 schriftlich belegt werden.");
    static NW_10 = new GostBelegungsfehler("NW_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Mindestens eine klassische Naturwissenschaft (Physik, Biologie, Chemie) muss durchgehend von Q1.1 bis Q2.2 belegt werden.", "Mindestens eines der Fächer Physik, Chemie oder Biologie muss in EF.1 belegt werden und durchgängig belegbar sein.");
    static NW_11 = new GostBelegungsfehler("NW_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "In EF.1 und EF.2 muss mindestens eine klassische Naturwissenschaft schriftlich belegt sein.", "Mindestens eines der Fächer Physik, Chemie oder Biologie muss in EF.1 schriftlich belegt werden.");
    static NW_FS_10 = new GostBelegungsfehler("NW_FS_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Von EF.1 bis Q2.2 müssen entweder zwei Naturwissenschaften oder zwei Fremdsprachen durchgehend gewählt werden. Hierbei ist eine Naturwissenschaft oder sind zwei Fremdsprachen schriftlich zu belegen. Zu den Fremdsprachen zählen auch in einer weiteren Fremdsprache unterrichtete Sachfächer.", "In EF.1 müssen entweder zwei Naturwissenschaften oder zwei Fremdsprachen belegt werden. Hierbei ist eine Naturwissenschaft oder sind zwei Fremdsprachen schriftlich zu belegen. Zu den Fremdsprachen zählen auch in einer weiteren Fremdsprache unterrichtete Sachfächer.");
    static NW_FS_11 = new GostBelegungsfehler("NW_FS_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.SCHRIFTLICHKEIT, "Zwei Fremdsprachen oder eines von mindestens zwei naturwissenschaftlichen Fächern muss von Q1.1 bis wenigstens Q2.1 schriftlich belegt werden.", null);
    static NW_FS_12_INFO = new GostBelegungsfehler("NW_FS_12_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Da von EF.1 bis Q2.2 weniger als zwei naturwissenschaftliche Fächer durchgehend belegt wurden, oder kein naturwissenschaftliches Fach schriftlich belegt wurde, liegt ausschließlich ein Sprachenschwerpunkt vor.", "Da in EF.1 weniger als zwei Naturwissenschaften belegt, oder keine schriftlich belegt wurden, müssen zwei Fremdsprachen bis Q2.2 durchgehend schriftlich belegt werden.");
    static NW_FS_13_INFO = new GostBelegungsfehler("NW_FS_13_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Da von EF.1 bis Q2.2 weniger als zwei Fremdsprachen schriftlich belegt wurden, liegt ausschließlich ein naturwissenschaftlicher Schwerpunkt vor.", "Da in EF.1 weniger als zwei Fremdsprachen schriftlich belegt wurden, müssen zwei Naturwissenschaften bis Q2.2 belegt, davon mindestens eine schriftlich belegt werden.");
    static PF_10 = new GostBelegungsfehler("PF_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Einführungsphase können keine Projektkurse belegt werden.", "In EF.1 können keine Projektkurse belegt werden.");
    static PF_11 = new GostBelegungsfehler("PF_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase kann maximal ein Projektkurs belegt werden.", null);
    static PF_12 = new GostBelegungsfehler("PF_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Projektkurse können nur dann belegt werden, wenn gleichzeitig oder maximal zwei Halbjahre vorher auch das Leitfach im gleichem Umfang belegt wurde.", null);
    static PF_13 = new GostBelegungsfehler("PF_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ein Projektkurs kann nur belegt werden, wenn in der Qualifikationsphase zeitgleich oder vorab auch sein Leitfach zwei Halbjahre lang belegt wurde.", null);
    static PF_14 = new GostBelegungsfehler("PF_14", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase kann maximal ein Projektkurs in zwei aufeinanderfolgenden Halbjahren belegt werden.", null);
    static PF_15 = new GostBelegungsfehler("PF_15", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Es existiert kein Projektkurs, der als besondere Lernleistung eingebracht werden kann.", null);
    static PF_16_INFO = new GostBelegungsfehler("PF_16_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Wird der Projektkurs als besondere Lernleistung in das Abitur eingebracht, so zählt er nicht mehr zu den einbringungsfähigen Kursen in Block I.", null);
    static PF_17_INFO = new GostBelegungsfehler("PF_17_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Ein Projektkurs soll nur im Ausnahmefall abgewählt werden. Bei einem abgewählten Projektkurs werden lediglich die Wochenstunden auf die Laufbahn angerechnet.", null);
    static PF_18 = new GostBelegungsfehler("PF_18", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ein Projektkurs kann nicht in der Q2.2 beginnen.", null);
    static RE_10 = new GostBelegungsfehler("RE_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Religionslehre muss wenigstens von EF.1-Q1.2 durchgehend belegt werden. Als Ersatz kann Philosophie dienen, sofern Philosophie nicht die einzige von EF.1 bis Q2.2 durchgehend belegte Gesellschaftswissenschaft ist. In diesen Fällen muss ein weiteres Fach der Gesellschaftswissenschaften als Religionsersatz dienen.", "Ein Religionskurs muss in EF.1 belegt werden. Als Ersatz kann Philosophie belegt werden, sofern eine weitere Gesellschaftswissenschaft bis zum Abitur belegt wird.");
    static RE_11 = new GostBelegungsfehler("RE_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Philosophie darf nicht die einzige durchgehend von Q1.1 bis Q2.2 belegte Geisteswissenschaft sein.", null);
    static SP_10 = new GostBelegungsfehler("SP_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Sport muss von EF.1 bis Q2.2 belegt werden.", "Sport muss in EF.1 belegt werden.");
    static STD_10 = new GostBelegungsfehler("STD_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Der Pflichtunterricht darf 102 Stunden nicht unterschreiten.", null);
    static STD_11_INFO = new GostBelegungsfehler("STD_11_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Der Pflichtunterricht darf nur in begründeten Ausnahmefällen 102 Stunden unterschreiten.", null);
    static SW_1_INFO = new GostBelegungsfehler("SW_1_INFO", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS, "Programmfehler: Dieser Hinweis ist für eine Gesamtbelegprüfung der Sek II nicht vorgesehen!", "Wird Sozialwissenschaften nicht in EF.1 belegt, so muss Sozialwissenschaften in der Qualifikationsphase als Zusatzkurs gewählt werden.");
    static SW_10 = new GostBelegungsfehler("SW_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Sozialwissenschaften muss von EF.1 bis wenigstens Q1.2 oder als Zusatzkurs (in der Regel von Q2.1 bis Q2.2) belegt werden.", null);
    static VF_10 = new GostBelegungsfehler("VF_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Einführungsphase können maximal vier Vertiefungskurse belegt werden.", null);
    static VF_11 = new GostBelegungsfehler("VF_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "In der Qualifikationsphase können maximal zwei Vertiefungskurse belegt werden.", null);
    static WST_10 = new GostBelegungsfehler("WST_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Die Summe der durchschnittlichen Jahreskursstunden von EF.1 bis Q2.2 darf 100 nicht unterschreiten.", null);
    static WST_20 = new GostBelegungsfehler("WST_20", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Die durchschnittliche Wochenstundenzahl muss in der Einführungsphase mindestens 34 Stunden betragen.", null);
    static WST_21 = new GostBelegungsfehler("WST_21", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Die durchschnittliche Wochenstundenzahl muss in der Qualifikationsphase mindestens 34 Stunden betragen.", null);
    static ZK_10 = new GostBelegungsfehler("ZK_10", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ein Zusatzkurs in Geschichte oder Sozialwissenschaften kann nur angewählt werden, wenn das Fach im vorangegangenen Halbjahr nicht belegt wurde.", null);
    static ZK_11 = new GostBelegungsfehler("ZK_11", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Ein Zusatzkurs in Geschichte oder Sozialwissenschaften muss in zwei aufeinanderfolgenden Halbjahren belegt werden.", null);
    static ZK_12 = new GostBelegungsfehler("ZK_12", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Zusatzkurse dürfen maximal in zwei aufeinanderfolgenden Halbjahren belegt werden.", null);
    static ZK_13 = new GostBelegungsfehler("ZK_13", GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.BELEGUNG, "Zusatzkurse dürfen nur einmal pro Fach belegt werden und können nicht in einem bilingualen Fach gewählt werden.", null);
    code;
    art;
    textGESAMT;
    textEF1;
    /**
     * Erstellt einen neuen Belegungsfehlerfür die Aufzählung (s.o.). Dabei wird ein
     * Text für die Gesamtprüfung und die EF.1-Prüfung angegeben.
     *
     * @param code         der eindeutige Code des Belegungsfehlers
     * @param art          die Fehlerart (Belegungsfehler, Schriftlichkeit oder Information)
     * @param textGESAMT   der zugeordnete Text für die Gesamtbelegprüfung oder null
     * @param textEF1      der zugeordnete Text für die EF.1-Prüfung oder null
     */
    constructor(code, art, textGESAMT, textEF1) {
        super();
        this.code = code;
        this.art = art;
        this.textGESAMT = textGESAMT !== null ? textGESAMT : "Programmfehler: Diese Belegungsfehlerart ist für eine Gesamt-Prüfung nicht vorgesehen!";
        this.textEF1 = (textEF1 !== null) ? textEF1 : "Programmfehler: Diese Belegungsfehlerart ist für eine Prüfung eingeschränkt auf die EF.1 nicht vorgesehen!";
    }
    /**
     * Gibt zurück, ob es sich bei dem Belegungsfehler nur um eine Information
     * und nicht um einen "echten" Fehler handelt.
     *
     * @return true, falls es sich nur um eine Information handelt, sonst false
     */
    istInfo() {
        return (this.art === GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS);
    }
    /**
     * Gibt zurück, ob es sich bei dem Belegungsfehler um einen "echten" Fehler handelt
     * und nicht nur um eine Information.
     *
     * @return true, falls es sich um einen "echten" Fehler handelt, sonst false
     */
    istFehler() {
        return (this.art !== GostBelegungsfehlerArt_1.GostBelegungsfehlerArt.HINWEIS);
    }
    /**
     * Gibt die Art des Belegungsfehlers zurück.
     *
     * @return die Art des Belegungsfehlers
     */
    getArt() {
        return this.art;
    }
    /**
     * Gibt je nach angegebenener Belegprüfungsart den zugehörigen Text für den Belegungsfehler
     * zurück.
     *
     * @param pruef_art   die Belegprüfungsart
     *
     * @return der zugehörige Text des Belegungsfehlers
     */
    getText(pruef_art) {
        if (pruef_art === GostBelegpruefungsArt_1.GostBelegpruefungsArt.EF1)
            return this.textEF1;
        if (pruef_art === GostBelegpruefungsArt_1.GostBelegpruefungsArt.GESAMT)
            return this.textGESAMT;
        return this.textGESAMT;
    }
    toString() {
        return this.code;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.abschluss.gost.GostBelegungsfehler'].includes(name);
    }
}
exports.GostBelegungsfehler = GostBelegungsfehler;
function cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehler(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehler = cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehler;
//# sourceMappingURL=GostBelegungsfehler.js.map