"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehlerArt = exports.GostBelegungsfehlerArt = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class GostBelegungsfehlerArt extends JavaObject_1.JavaObject {
    static BELEGUNG = new GostBelegungsfehlerArt("BELEGUNG");
    static SCHRIFTLICHKEIT = new GostBelegungsfehlerArt("SCHRIFTLICHKEIT");
    static HINWEIS = new GostBelegungsfehlerArt("HINWEIS");
    kuerzel;
    /**
     * Erzeugt ein neues Abitur-Belegungsfehler-Objekt
     *
     * @param kuerzel        das Kürzel der Fehler-Art
     */
    constructor(kuerzel) {
        super();
        this.kuerzel = kuerzel;
    }
    /**
     * Gibt die Belegungsfehler-Art anhand des übergebenen Kürzels zurück.
     *
     * @param kuerzel    das Kürzel der Belegungsfehler-Art
     *
     * @return die Belegungsfehler-Art
     */
    static fromKuerzel(kuerzel) {
        if (kuerzel === null)
            return null;
        switch (kuerzel) {
            case "BELEGUNG":
                return GostBelegungsfehlerArt.BELEGUNG;
            case "SCHRIFTLICHKEIT":
                return GostBelegungsfehlerArt.SCHRIFTLICHKEIT;
            case "HINWEIS":
                return GostBelegungsfehlerArt.HINWEIS;
        }
        return null;
    }
    toString() {
        return this.kuerzel;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.abschluss.gost.GostBelegungsfehlerArt'].includes(name);
    }
}
exports.GostBelegungsfehlerArt = GostBelegungsfehlerArt;
function cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehlerArt(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehlerArt = cast_de_nrw_schule_svws_core_abschluss_gost_GostBelegungsfehlerArt;
//# sourceMappingURL=GostBelegungsfehlerArt.js.map