import { GostBelegpruefungsArt } from '../../../../core/abschluss/gost/GostBelegpruefungsArt';
import { GostBelegpruefung } from '../../../../core/abschluss/gost/GostBelegpruefung';
import { AbiturdatenManager } from '../../../../core/abschluss/gost/AbiturdatenManager';
export declare class Naturwissenschaften extends GostBelegpruefung {
    private naturwissenschaften;
    private naturwissenschaften_klassisch;
    private anzahl_durchgehend;
    private anzahl_schriftlich_durchgehend;
    /**
     * Erstellt eine neue Belegprüfung für das Fach Mathematik.
     *
     * @param manager         der Daten-Manager für die Abiturdaten
     * @param pruefungs_art   die Art der durchzuführenden Prüfung (z.B. EF.1 oder GESAMT)
     */
    constructor(manager: AbiturdatenManager, pruefungs_art: GostBelegpruefungsArt);
    protected init(): void;
    protected pruefeEF1(): void;
    protected pruefeGesamt(): void;
    /**
     * Gibt die Anzahl der durchgehend belegten bzw. belegbaren Naturwissenschaften zurück.
     *
     * @return die Anzahl der durchgehend belegten bzw. belegbaren Naturwissenschaften zurück.
     */
    getAnzahlDurchgehendBelegt(): number;
    /**
     * Gibt die Anzahl der durchgehend schriftlich belegten bzw. belegbaren Naturwissenschaften zurück.
     * Durchgehend schriftlich bedeutet, dass das Fach mind. von Q1.1 bus Q2.1 schriftlich belegt wurde.
     *
     * @return die Anzahl der durchgehend schriftlich belegten bzw. belegbaren Naturwissenschaften zurück.
     */
    getAnzahlDurchgehendSchritflichBelegt(): number;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_abschluss_gost_belegpruefung_Naturwissenschaften(obj: unknown): Naturwissenschaften;
