import { Naturwissenschaften } from '../../../../core/abschluss/gost/belegpruefung/Naturwissenschaften';
import { Fremdsprachen } from '../../../../core/abschluss/gost/belegpruefung/Fremdsprachen';
import { GostBelegpruefungsArt } from '../../../../core/abschluss/gost/GostBelegpruefungsArt';
import { GostBelegpruefung } from '../../../../core/abschluss/gost/GostBelegpruefung';
import { AbiturdatenManager } from '../../../../core/abschluss/gost/AbiturdatenManager';
export declare class Schwerpunkt extends GostBelegpruefung {
    /**
     * Erstellt eine neue Belegprüfung für den Schwerpunkt.
     *
     * @param manager             der Daten-Manager für die Abiturdaten
     * @param pruefungs_art       die Art der durchzuführenden Prüfung (z.B. EF.1 oder GESAMT)
     * @param pruefung_sprachen   das Ergebnis für die Belegprüfung der Sprachen
     * @param pruefung_nawi       das Ergebnis für die Belegprüfung der Naturwissenschaften
     */
    constructor(manager: AbiturdatenManager, pruefungs_art: GostBelegpruefungsArt, pruefung_sprachen: Fremdsprachen, pruefung_nawi: Naturwissenschaften);
    protected init(): void;
    protected pruefeEF1(): void;
    protected pruefeGesamt(): void;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_abschluss_gost_belegpruefung_Schwerpunkt(obj: unknown): Schwerpunkt;
