import { JavaObject } from '../../../java/lang/JavaObject';
export declare class LinkedCollectionElement<E> extends JavaObject {
    private _value;
    private _prev;
    private _next;
    /**
     * Erstellt eine neues LinkedCollectionElement mit den Wert _value und den
     * übergebenen Vorgänger bzw. Nachfolger
     *
     * @param value   der Wert des SimpleCollectionElements
     * @param prev    der Vorgänger
     * @param next    der Nachfolger
     */
    constructor(value: E, prev: LinkedCollectionElement<E> | null, next: LinkedCollectionElement<E> | null);
    /**
     * Gibt den Wert des Elements zurück.
     *
     * @return der Wert des Elements
     */
    getValue(): E;
    /**
     * Ersetzt den Wert des Elements.
     *
     * @param value   der neue Wert des Elements
     *
     * @return der alte Wert des Elements
     */
    setValue(value: E): E;
    /**
     * Gibt den Vorgänger des Elementes zurück.
     *
     * @return   das LinkedCollectionElement das der Vorgänger des Elementes ist
     */
    getPrev(): LinkedCollectionElement<E> | null;
    /**
     * Setzt den Vorgänger des Elementes auf _prev
     *
     * @param prev   der Vorgänger des Elements
     */
    setPrev(prev: LinkedCollectionElement<E> | null): void;
    /**
     * Gibt den Nachfolger des Elementes zurück.
     *
     * @return   das LinkedCollectionElement das der Nachfolger des Elementes ist
     */
    getNext(): LinkedCollectionElement<E> | null;
    /**
     * Setzt den Nachfolger des Elementes auf _next
     *
     * @param next   der Nachfolger des Elements
     */
    setNext(next: LinkedCollectionElement<E> | null): void;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_adt_collection_LinkedCollectionElement<E>(obj: unknown): LinkedCollectionElement<E>;
