"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_adt_map_AVLMapIntervall = exports.AVLMapIntervall = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class AVLMapIntervall extends JavaObject_1.JavaObject {
    static _INFINITY_MINUS = new Object();
    static _INFINITY_PLUS = new Object();
    from;
    fromInc;
    to;
    toInc;
    /**
     * @param pFrom    Der Anfang des Intervalls.
     * @param pFromInc Gibt an, ob der Intervall-Anfang inklusive ist.
     * @param pTo      Das Ende des Intervalls.
     * @param pToInc   Gibt an, ob das Intervall-Ende inklusive ist.
     */
    constructor(pFrom, pFromInc, pTo, pToInc) {
        super();
        this.from = pFrom;
        this.fromInc = pFromInc;
        this.to = pTo;
        this.toInc = pToInc;
    }
    toString() {
        let sFrom = (this.from === AVLMapIntervall._INFINITY_MINUS) ? "-INF" : "" + this.from;
        let sTo = (this.to === AVLMapIntervall._INFINITY_PLUS) ? "+INF" : "" + this.to;
        return "[" + sFrom.valueOf() + ", " + this.fromInc + ", " + sTo.valueOf() + ", " + this.toInc + "]";
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.adt.map.AVLMapIntervall'].includes(name);
    }
}
exports.AVLMapIntervall = AVLMapIntervall;
function cast_de_nrw_schule_svws_core_adt_map_AVLMapIntervall(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_adt_map_AVLMapIntervall = cast_de_nrw_schule_svws_core_adt_map_AVLMapIntervall;
//# sourceMappingURL=AVLMapIntervall.js.map