"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_Sprachendaten = exports.Sprachendaten = void 0;
const JavaObject_1 = require("../../java/lang/JavaObject");
const Sprachbelegung_1 = require("../../core/data/Sprachbelegung");
const Sprachpruefung_1 = require("../../core/data/Sprachpruefung");
const Vector_1 = require("../../java/util/Vector");
class Sprachendaten extends JavaObject_1.JavaObject {
    schuelerID = 0;
    belegungen = new Vector_1.Vector();
    pruefungen = new Vector_1.Vector();
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.Sprachendaten'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new Sprachendaten();
        if (typeof obj.schuelerID === "undefined")
            throw new Error('invalid json format, missing attribute schuelerID');
        result.schuelerID = obj.schuelerID;
        if (!!obj.belegungen) {
            for (let elem of obj.belegungen) {
                result.belegungen?.add(Sprachbelegung_1.Sprachbelegung.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        if (!!obj.pruefungen) {
            for (let elem of obj.pruefungen) {
                result.pruefungen?.add(Sprachpruefung_1.Sprachpruefung.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"schuelerID" : ' + obj.schuelerID + ',';
        if (!obj.belegungen) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.belegungen.size(); i++) {
                let elem = obj.belegungen.get(i);
                result += Sprachbelegung_1.Sprachbelegung.transpilerToJSON(elem);
                if (i < obj.belegungen.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        if (!obj.pruefungen) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.pruefungen.size(); i++) {
                let elem = obj.pruefungen.get(i);
                result += Sprachpruefung_1.Sprachpruefung.transpilerToJSON(elem);
                if (i < obj.pruefungen.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.schuelerID !== "undefined") {
            result += '"schuelerID" : ' + obj.schuelerID + ',';
        }
        if (typeof obj.belegungen !== "undefined") {
            if (!obj.belegungen) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.belegungen.size(); i++) {
                    let elem = obj.belegungen.get(i);
                    result += Sprachbelegung_1.Sprachbelegung.transpilerToJSON(elem);
                    if (i < obj.belegungen.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        if (typeof obj.pruefungen !== "undefined") {
            if (!obj.pruefungen) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.pruefungen.size(); i++) {
                    let elem = obj.pruefungen.get(i);
                    result += Sprachpruefung_1.Sprachpruefung.transpilerToJSON(elem);
                    if (i < obj.pruefungen.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.Sprachendaten = Sprachendaten;
function cast_de_nrw_schule_svws_core_data_Sprachendaten(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_Sprachendaten = cast_de_nrw_schule_svws_core_data_Sprachendaten;
//# sourceMappingURL=Sprachendaten.js.map