"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_abschluss_GEAbschlussFaecher = exports.GEAbschlussFaecher = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const GEAbschlussFach_1 = require("../../../core/data/abschluss/GEAbschlussFach");
const Vector_1 = require("../../../java/util/Vector");
class GEAbschlussFaecher extends JavaObject_1.JavaObject {
    schuljahr = 0;
    abschnitt = 0;
    jahrgang = null;
    faecher = new Vector_1.Vector();
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.abschluss.GEAbschlussFaecher'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new GEAbschlussFaecher();
        if (typeof obj.schuljahr === "undefined")
            throw new Error('invalid json format, missing attribute schuljahr');
        result.schuljahr = obj.schuljahr;
        if (typeof obj.abschnitt === "undefined")
            throw new Error('invalid json format, missing attribute abschnitt');
        result.abschnitt = obj.abschnitt;
        result.jahrgang = typeof obj.jahrgang === "undefined" ? null : obj.jahrgang;
        if (!!obj.faecher) {
            for (let elem of obj.faecher) {
                result.faecher?.add(GEAbschlussFach_1.GEAbschlussFach.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"schuljahr" : ' + obj.schuljahr + ',';
        result += '"abschnitt" : ' + obj.abschnitt + ',';
        result += '"jahrgang" : ' + ((!obj.jahrgang) ? 'null' : '"' + obj.jahrgang.valueOf() + '"') + ',';
        if (!obj.faecher) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.faecher.size(); i++) {
                let elem = obj.faecher.get(i);
                result += GEAbschlussFach_1.GEAbschlussFach.transpilerToJSON(elem);
                if (i < obj.faecher.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.schuljahr !== "undefined") {
            result += '"schuljahr" : ' + obj.schuljahr + ',';
        }
        if (typeof obj.abschnitt !== "undefined") {
            result += '"abschnitt" : ' + obj.abschnitt + ',';
        }
        if (typeof obj.jahrgang !== "undefined") {
            result += '"jahrgang" : ' + ((!obj.jahrgang) ? 'null' : '"' + obj.jahrgang.valueOf() + '"') + ',';
        }
        if (typeof obj.faecher !== "undefined") {
            if (!obj.faecher) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.faecher.size(); i++) {
                    let elem = obj.faecher.get(i);
                    result += GEAbschlussFach_1.GEAbschlussFach.transpilerToJSON(elem);
                    if (i < obj.faecher.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.GEAbschlussFaecher = GEAbschlussFaecher;
function cast_de_nrw_schule_svws_core_data_abschluss_GEAbschlussFaecher(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_abschluss_GEAbschlussFaecher = cast_de_nrw_schule_svws_core_data_abschluss_GEAbschlussFaecher;
//# sourceMappingURL=GEAbschlussFaecher.js.map