"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_enm_ENMBKAbschluss = exports.ENMBKAbschluss = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const ENMBKFach_1 = require("../../../core/data/enm/ENMBKFach");
const Vector_1 = require("../../../java/util/Vector");
class ENMBKAbschluss extends JavaObject_1.JavaObject {
    hatZulassung = false;
    hatBestanden = false;
    hatZulassungErweiterteBeruflicheKenntnisse = false;
    hatErworbenErweiterteBeruflicheKenntnisse = false;
    notePraktischePruefung = null;
    noteKolloqium = null;
    hatZulassungBerufsabschlusspruefung = false;
    hatBestandenBerufsabschlusspruefung = false;
    themaAbschlussarbeit = null;
    istVorhandenBerufsabschlusspruefung = false;
    noteFachpraxis = null;
    istFachpraktischerTeilAusreichend = false;
    faecher = new Vector_1.Vector();
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.enm.ENMBKAbschluss'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new ENMBKAbschluss();
        if (typeof obj.hatZulassung === "undefined")
            throw new Error('invalid json format, missing attribute hatZulassung');
        result.hatZulassung = obj.hatZulassung;
        if (typeof obj.hatBestanden === "undefined")
            throw new Error('invalid json format, missing attribute hatBestanden');
        result.hatBestanden = obj.hatBestanden;
        if (typeof obj.hatZulassungErweiterteBeruflicheKenntnisse === "undefined")
            throw new Error('invalid json format, missing attribute hatZulassungErweiterteBeruflicheKenntnisse');
        result.hatZulassungErweiterteBeruflicheKenntnisse = obj.hatZulassungErweiterteBeruflicheKenntnisse;
        if (typeof obj.hatErworbenErweiterteBeruflicheKenntnisse === "undefined")
            throw new Error('invalid json format, missing attribute hatErworbenErweiterteBeruflicheKenntnisse');
        result.hatErworbenErweiterteBeruflicheKenntnisse = obj.hatErworbenErweiterteBeruflicheKenntnisse;
        result.notePraktischePruefung = typeof obj.notePraktischePruefung === "undefined" ? null : obj.notePraktischePruefung;
        result.noteKolloqium = typeof obj.noteKolloqium === "undefined" ? null : obj.noteKolloqium;
        if (typeof obj.hatZulassungBerufsabschlusspruefung === "undefined")
            throw new Error('invalid json format, missing attribute hatZulassungBerufsabschlusspruefung');
        result.hatZulassungBerufsabschlusspruefung = obj.hatZulassungBerufsabschlusspruefung;
        if (typeof obj.hatBestandenBerufsabschlusspruefung === "undefined")
            throw new Error('invalid json format, missing attribute hatBestandenBerufsabschlusspruefung');
        result.hatBestandenBerufsabschlusspruefung = obj.hatBestandenBerufsabschlusspruefung;
        result.themaAbschlussarbeit = typeof obj.themaAbschlussarbeit === "undefined" ? null : obj.themaAbschlussarbeit;
        if (typeof obj.istVorhandenBerufsabschlusspruefung === "undefined")
            throw new Error('invalid json format, missing attribute istVorhandenBerufsabschlusspruefung');
        result.istVorhandenBerufsabschlusspruefung = obj.istVorhandenBerufsabschlusspruefung;
        result.noteFachpraxis = typeof obj.noteFachpraxis === "undefined" ? null : obj.noteFachpraxis;
        if (typeof obj.istFachpraktischerTeilAusreichend === "undefined")
            throw new Error('invalid json format, missing attribute istFachpraktischerTeilAusreichend');
        result.istFachpraktischerTeilAusreichend = obj.istFachpraktischerTeilAusreichend;
        if (!!obj.faecher) {
            for (let elem of obj.faecher) {
                result.faecher?.add(ENMBKFach_1.ENMBKFach.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"hatZulassung" : ' + obj.hatZulassung + ',';
        result += '"hatBestanden" : ' + obj.hatBestanden + ',';
        result += '"hatZulassungErweiterteBeruflicheKenntnisse" : ' + obj.hatZulassungErweiterteBeruflicheKenntnisse + ',';
        result += '"hatErworbenErweiterteBeruflicheKenntnisse" : ' + obj.hatErworbenErweiterteBeruflicheKenntnisse + ',';
        result += '"notePraktischePruefung" : ' + ((!obj.notePraktischePruefung) ? 'null' : '"' + obj.notePraktischePruefung.valueOf() + '"') + ',';
        result += '"noteKolloqium" : ' + ((!obj.noteKolloqium) ? 'null' : '"' + obj.noteKolloqium.valueOf() + '"') + ',';
        result += '"hatZulassungBerufsabschlusspruefung" : ' + obj.hatZulassungBerufsabschlusspruefung + ',';
        result += '"hatBestandenBerufsabschlusspruefung" : ' + obj.hatBestandenBerufsabschlusspruefung + ',';
        result += '"themaAbschlussarbeit" : ' + ((!obj.themaAbschlussarbeit) ? 'null' : '"' + obj.themaAbschlussarbeit.valueOf() + '"') + ',';
        result += '"istVorhandenBerufsabschlusspruefung" : ' + obj.istVorhandenBerufsabschlusspruefung + ',';
        result += '"noteFachpraxis" : ' + ((!obj.noteFachpraxis) ? 'null' : '"' + obj.noteFachpraxis.valueOf() + '"') + ',';
        result += '"istFachpraktischerTeilAusreichend" : ' + obj.istFachpraktischerTeilAusreichend + ',';
        if (!obj.faecher) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.faecher.size(); i++) {
                let elem = obj.faecher.get(i);
                result += ENMBKFach_1.ENMBKFach.transpilerToJSON(elem);
                if (i < obj.faecher.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.hatZulassung !== "undefined") {
            result += '"hatZulassung" : ' + obj.hatZulassung + ',';
        }
        if (typeof obj.hatBestanden !== "undefined") {
            result += '"hatBestanden" : ' + obj.hatBestanden + ',';
        }
        if (typeof obj.hatZulassungErweiterteBeruflicheKenntnisse !== "undefined") {
            result += '"hatZulassungErweiterteBeruflicheKenntnisse" : ' + obj.hatZulassungErweiterteBeruflicheKenntnisse + ',';
        }
        if (typeof obj.hatErworbenErweiterteBeruflicheKenntnisse !== "undefined") {
            result += '"hatErworbenErweiterteBeruflicheKenntnisse" : ' + obj.hatErworbenErweiterteBeruflicheKenntnisse + ',';
        }
        if (typeof obj.notePraktischePruefung !== "undefined") {
            result += '"notePraktischePruefung" : ' + ((!obj.notePraktischePruefung) ? 'null' : '"' + obj.notePraktischePruefung.valueOf() + '"') + ',';
        }
        if (typeof obj.noteKolloqium !== "undefined") {
            result += '"noteKolloqium" : ' + ((!obj.noteKolloqium) ? 'null' : '"' + obj.noteKolloqium.valueOf() + '"') + ',';
        }
        if (typeof obj.hatZulassungBerufsabschlusspruefung !== "undefined") {
            result += '"hatZulassungBerufsabschlusspruefung" : ' + obj.hatZulassungBerufsabschlusspruefung + ',';
        }
        if (typeof obj.hatBestandenBerufsabschlusspruefung !== "undefined") {
            result += '"hatBestandenBerufsabschlusspruefung" : ' + obj.hatBestandenBerufsabschlusspruefung + ',';
        }
        if (typeof obj.themaAbschlussarbeit !== "undefined") {
            result += '"themaAbschlussarbeit" : ' + ((!obj.themaAbschlussarbeit) ? 'null' : '"' + obj.themaAbschlussarbeit.valueOf() + '"') + ',';
        }
        if (typeof obj.istVorhandenBerufsabschlusspruefung !== "undefined") {
            result += '"istVorhandenBerufsabschlusspruefung" : ' + obj.istVorhandenBerufsabschlusspruefung + ',';
        }
        if (typeof obj.noteFachpraxis !== "undefined") {
            result += '"noteFachpraxis" : ' + ((!obj.noteFachpraxis) ? 'null' : '"' + obj.noteFachpraxis.valueOf() + '"') + ',';
        }
        if (typeof obj.istFachpraktischerTeilAusreichend !== "undefined") {
            result += '"istFachpraktischerTeilAusreichend" : ' + obj.istFachpraktischerTeilAusreichend + ',';
        }
        if (typeof obj.faecher !== "undefined") {
            if (!obj.faecher) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.faecher.size(); i++) {
                    let elem = obj.faecher.get(i);
                    result += ENMBKFach_1.ENMBKFach.transpilerToJSON(elem);
                    if (i < obj.faecher.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.ENMBKAbschluss = ENMBKAbschluss;
function cast_de_nrw_schule_svws_core_data_enm_ENMBKAbschluss(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_enm_ENMBKAbschluss = cast_de_nrw_schule_svws_core_data_enm_ENMBKAbschluss;
//# sourceMappingURL=ENMBKAbschluss.js.map