"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_enm_ENMBKFach = exports.ENMBKFach = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class ENMBKFach extends JavaObject_1.JavaObject {
    fachID = 0;
    lehrerID = 0;
    istSchriftlich = false;
    vornote = null;
    noteSchriftlichePruefung = null;
    muendlichePruefung = false;
    muendlichePruefungFreiwillig = false;
    noteMuendlichePruefung = null;
    istSchriftlichBerufsabschluss = false;
    noteBerufsabschluss = null;
    abschlussnote = null;
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.enm.ENMBKFach'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new ENMBKFach();
        if (typeof obj.fachID === "undefined")
            throw new Error('invalid json format, missing attribute fachID');
        result.fachID = obj.fachID;
        if (typeof obj.lehrerID === "undefined")
            throw new Error('invalid json format, missing attribute lehrerID');
        result.lehrerID = obj.lehrerID;
        if (typeof obj.istSchriftlich === "undefined")
            throw new Error('invalid json format, missing attribute istSchriftlich');
        result.istSchriftlich = obj.istSchriftlich;
        result.vornote = typeof obj.vornote === "undefined" ? null : obj.vornote;
        result.noteSchriftlichePruefung = typeof obj.noteSchriftlichePruefung === "undefined" ? null : obj.noteSchriftlichePruefung;
        if (typeof obj.muendlichePruefung === "undefined")
            throw new Error('invalid json format, missing attribute muendlichePruefung');
        result.muendlichePruefung = obj.muendlichePruefung;
        if (typeof obj.muendlichePruefungFreiwillig === "undefined")
            throw new Error('invalid json format, missing attribute muendlichePruefungFreiwillig');
        result.muendlichePruefungFreiwillig = obj.muendlichePruefungFreiwillig;
        result.noteMuendlichePruefung = typeof obj.noteMuendlichePruefung === "undefined" ? null : obj.noteMuendlichePruefung;
        if (typeof obj.istSchriftlichBerufsabschluss === "undefined")
            throw new Error('invalid json format, missing attribute istSchriftlichBerufsabschluss');
        result.istSchriftlichBerufsabschluss = obj.istSchriftlichBerufsabschluss;
        result.noteBerufsabschluss = typeof obj.noteBerufsabschluss === "undefined" ? null : obj.noteBerufsabschluss;
        result.abschlussnote = typeof obj.abschlussnote === "undefined" ? null : obj.abschlussnote;
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"fachID" : ' + obj.fachID + ',';
        result += '"lehrerID" : ' + obj.lehrerID + ',';
        result += '"istSchriftlich" : ' + obj.istSchriftlich + ',';
        result += '"vornote" : ' + ((!obj.vornote) ? 'null' : '"' + obj.vornote.valueOf() + '"') + ',';
        result += '"noteSchriftlichePruefung" : ' + ((!obj.noteSchriftlichePruefung) ? 'null' : '"' + obj.noteSchriftlichePruefung.valueOf() + '"') + ',';
        result += '"muendlichePruefung" : ' + obj.muendlichePruefung + ',';
        result += '"muendlichePruefungFreiwillig" : ' + obj.muendlichePruefungFreiwillig + ',';
        result += '"noteMuendlichePruefung" : ' + ((!obj.noteMuendlichePruefung) ? 'null' : '"' + obj.noteMuendlichePruefung.valueOf() + '"') + ',';
        result += '"istSchriftlichBerufsabschluss" : ' + obj.istSchriftlichBerufsabschluss + ',';
        result += '"noteBerufsabschluss" : ' + ((!obj.noteBerufsabschluss) ? 'null' : '"' + obj.noteBerufsabschluss.valueOf() + '"') + ',';
        result += '"abschlussnote" : ' + ((!obj.abschlussnote) ? 'null' : '"' + obj.abschlussnote.valueOf() + '"') + ',';
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.fachID !== "undefined") {
            result += '"fachID" : ' + obj.fachID + ',';
        }
        if (typeof obj.lehrerID !== "undefined") {
            result += '"lehrerID" : ' + obj.lehrerID + ',';
        }
        if (typeof obj.istSchriftlich !== "undefined") {
            result += '"istSchriftlich" : ' + obj.istSchriftlich + ',';
        }
        if (typeof obj.vornote !== "undefined") {
            result += '"vornote" : ' + ((!obj.vornote) ? 'null' : '"' + obj.vornote.valueOf() + '"') + ',';
        }
        if (typeof obj.noteSchriftlichePruefung !== "undefined") {
            result += '"noteSchriftlichePruefung" : ' + ((!obj.noteSchriftlichePruefung) ? 'null' : '"' + obj.noteSchriftlichePruefung.valueOf() + '"') + ',';
        }
        if (typeof obj.muendlichePruefung !== "undefined") {
            result += '"muendlichePruefung" : ' + obj.muendlichePruefung + ',';
        }
        if (typeof obj.muendlichePruefungFreiwillig !== "undefined") {
            result += '"muendlichePruefungFreiwillig" : ' + obj.muendlichePruefungFreiwillig + ',';
        }
        if (typeof obj.noteMuendlichePruefung !== "undefined") {
            result += '"noteMuendlichePruefung" : ' + ((!obj.noteMuendlichePruefung) ? 'null' : '"' + obj.noteMuendlichePruefung.valueOf() + '"') + ',';
        }
        if (typeof obj.istSchriftlichBerufsabschluss !== "undefined") {
            result += '"istSchriftlichBerufsabschluss" : ' + obj.istSchriftlichBerufsabschluss + ',';
        }
        if (typeof obj.noteBerufsabschluss !== "undefined") {
            result += '"noteBerufsabschluss" : ' + ((!obj.noteBerufsabschluss) ? 'null' : '"' + obj.noteBerufsabschluss.valueOf() + '"') + ',';
        }
        if (typeof obj.abschlussnote !== "undefined") {
            result += '"abschlussnote" : ' + ((!obj.abschlussnote) ? 'null' : '"' + obj.abschlussnote.valueOf() + '"') + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.ENMBKFach = ENMBKFach;
function cast_de_nrw_schule_svws_core_data_enm_ENMBKFach(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_enm_ENMBKFach = cast_de_nrw_schule_svws_core_data_enm_ENMBKFach;
//# sourceMappingURL=ENMBKFach.js.map