import { JavaObject } from '../../../java/lang/JavaObject';
import { ENMKlasse } from '../../../core/data/enm/ENMKlasse';
import { ENMTeilleistungsart } from '../../../core/data/enm/ENMTeilleistungsart';
import { ENMFach } from '../../../core/data/enm/ENMFach';
import { ENMJahrgang } from '../../../core/data/enm/ENMJahrgang';
import { ENMLerngruppe } from '../../../core/data/enm/ENMLerngruppe';
import { ENMLehrer } from '../../../core/data/enm/ENMLehrer';
import { ENMSchueler } from '../../../core/data/enm/ENMSchueler';
import { ENMNote } from '../../../core/data/enm/ENMNote';
import { Vector } from '../../../java/util/Vector';
import { ENMFoerderschwerpunkt } from '../../../core/data/enm/ENMFoerderschwerpunkt';
import { ENMFloskelgruppe } from '../../../core/data/enm/ENMFloskelgruppe';
export declare class ENMDaten extends JavaObject {
    enmRevision: number;
    schuljahr: number;
    anzahlAbschnitte: number;
    aktuellerAbschnitt: number;
    publicKey: String | null;
    lehrerID: number;
    fehlstundenEingabe: boolean;
    fehlstundenSIFachbezogen: boolean;
    fehlstundenSIIFachbezogen: boolean;
    schulform: String | null;
    mailadresse: String | null;
    noten: Vector<ENMNote>;
    foerderschwerpunkte: Vector<ENMFoerderschwerpunkt>;
    jahrgaenge: Vector<ENMJahrgang>;
    klassen: Vector<ENMKlasse>;
    floskelgruppen: Vector<ENMFloskelgruppe>;
    lehrer: Vector<ENMLehrer>;
    faecher: Vector<ENMFach>;
    teilleistungsarten: Vector<ENMTeilleistungsart>;
    lerngruppen: Vector<ENMLerngruppe>;
    schueler: Vector<ENMSchueler>;
    constructor();
    isTranspiledInstanceOf(name: string): boolean;
    static transpilerFromJSON(json: string): ENMDaten;
    static transpilerToJSON(obj: ENMDaten): string;
    static transpilerToJSONPatch(obj: Partial<ENMDaten>): string;
}
export declare function cast_de_nrw_schule_svws_core_data_enm_ENMDaten(obj: unknown): ENMDaten;
