"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_enm_ENMLeistung = exports.ENMLeistung = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const ENMTeilleistung_1 = require("../../../core/data/enm/ENMTeilleistung");
const Vector_1 = require("../../../java/util/Vector");
class ENMLeistung extends JavaObject_1.JavaObject {
    id = 0;
    lerngruppenID = 0;
    note = null;
    istSchriftlich = null;
    abiturfach = null;
    fehlstundenGesamt = null;
    fehlstundenUnentschuldigt = null;
    fachbezogeneBemerkungen = null;
    neueZuweisungKursart = null;
    teilleistungen = new Vector_1.Vector();
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.enm.ENMLeistung'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new ENMLeistung();
        if (typeof obj.id === "undefined")
            throw new Error('invalid json format, missing attribute id');
        result.id = obj.id;
        if (typeof obj.lerngruppenID === "undefined")
            throw new Error('invalid json format, missing attribute lerngruppenID');
        result.lerngruppenID = obj.lerngruppenID;
        result.note = typeof obj.note === "undefined" ? null : obj.note;
        result.istSchriftlich = typeof obj.istSchriftlich === "undefined" ? null : obj.istSchriftlich;
        result.abiturfach = typeof obj.abiturfach === "undefined" ? null : obj.abiturfach;
        result.fehlstundenGesamt = typeof obj.fehlstundenGesamt === "undefined" ? null : obj.fehlstundenGesamt;
        result.fehlstundenUnentschuldigt = typeof obj.fehlstundenUnentschuldigt === "undefined" ? null : obj.fehlstundenUnentschuldigt;
        result.fachbezogeneBemerkungen = typeof obj.fachbezogeneBemerkungen === "undefined" ? null : obj.fachbezogeneBemerkungen;
        result.neueZuweisungKursart = typeof obj.neueZuweisungKursart === "undefined" ? null : obj.neueZuweisungKursart;
        if (!!obj.teilleistungen) {
            for (let elem of obj.teilleistungen) {
                result.teilleistungen?.add(ENMTeilleistung_1.ENMTeilleistung.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"id" : ' + obj.id + ',';
        result += '"lerngruppenID" : ' + obj.lerngruppenID + ',';
        result += '"note" : ' + ((!obj.note) ? 'null' : '"' + obj.note.valueOf() + '"') + ',';
        result += '"istSchriftlich" : ' + ((!obj.istSchriftlich) ? 'null' : obj.istSchriftlich.valueOf()) + ',';
        result += '"abiturfach" : ' + ((!obj.abiturfach) ? 'null' : obj.abiturfach.valueOf()) + ',';
        result += '"fehlstundenGesamt" : ' + ((!obj.fehlstundenGesamt) ? 'null' : obj.fehlstundenGesamt.valueOf()) + ',';
        result += '"fehlstundenUnentschuldigt" : ' + ((!obj.fehlstundenUnentschuldigt) ? 'null' : obj.fehlstundenUnentschuldigt.valueOf()) + ',';
        result += '"fachbezogeneBemerkungen" : ' + ((!obj.fachbezogeneBemerkungen) ? 'null' : '"' + obj.fachbezogeneBemerkungen.valueOf() + '"') + ',';
        result += '"neueZuweisungKursart" : ' + ((!obj.neueZuweisungKursart) ? 'null' : '"' + obj.neueZuweisungKursart.valueOf() + '"') + ',';
        if (!obj.teilleistungen) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.teilleistungen.size(); i++) {
                let elem = obj.teilleistungen.get(i);
                result += ENMTeilleistung_1.ENMTeilleistung.transpilerToJSON(elem);
                if (i < obj.teilleistungen.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.id !== "undefined") {
            result += '"id" : ' + obj.id + ',';
        }
        if (typeof obj.lerngruppenID !== "undefined") {
            result += '"lerngruppenID" : ' + obj.lerngruppenID + ',';
        }
        if (typeof obj.note !== "undefined") {
            result += '"note" : ' + ((!obj.note) ? 'null' : '"' + obj.note.valueOf() + '"') + ',';
        }
        if (typeof obj.istSchriftlich !== "undefined") {
            result += '"istSchriftlich" : ' + ((!obj.istSchriftlich) ? 'null' : obj.istSchriftlich.valueOf()) + ',';
        }
        if (typeof obj.abiturfach !== "undefined") {
            result += '"abiturfach" : ' + ((!obj.abiturfach) ? 'null' : obj.abiturfach.valueOf()) + ',';
        }
        if (typeof obj.fehlstundenGesamt !== "undefined") {
            result += '"fehlstundenGesamt" : ' + ((!obj.fehlstundenGesamt) ? 'null' : obj.fehlstundenGesamt.valueOf()) + ',';
        }
        if (typeof obj.fehlstundenUnentschuldigt !== "undefined") {
            result += '"fehlstundenUnentschuldigt" : ' + ((!obj.fehlstundenUnentschuldigt) ? 'null' : obj.fehlstundenUnentschuldigt.valueOf()) + ',';
        }
        if (typeof obj.fachbezogeneBemerkungen !== "undefined") {
            result += '"fachbezogeneBemerkungen" : ' + ((!obj.fachbezogeneBemerkungen) ? 'null' : '"' + obj.fachbezogeneBemerkungen.valueOf() + '"') + ',';
        }
        if (typeof obj.neueZuweisungKursart !== "undefined") {
            result += '"neueZuweisungKursart" : ' + ((!obj.neueZuweisungKursart) ? 'null' : '"' + obj.neueZuweisungKursart.valueOf() + '"') + ',';
        }
        if (typeof obj.teilleistungen !== "undefined") {
            if (!obj.teilleistungen) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.teilleistungen.size(); i++) {
                    let elem = obj.teilleistungen.get(i);
                    result += ENMTeilleistung_1.ENMTeilleistung.transpilerToJSON(elem);
                    if (i < obj.teilleistungen.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.ENMLeistung = ENMLeistung;
function cast_de_nrw_schule_svws_core_data_enm_ENMLeistung(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_enm_ENMLeistung = cast_de_nrw_schule_svws_core_data_enm_ENMLeistung;
//# sourceMappingURL=ENMLeistung.js.map