"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_enm_ENMLerngruppe = exports.ENMLerngruppe = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const Vector_1 = require("../../../java/util/Vector");
class ENMLerngruppe extends JavaObject_1.JavaObject {
    id = 0;
    kID = 0;
    fachID = 0;
    kursartID = null;
    bezeichnung = null;
    kursartKuerzel = null;
    bilingualeSprache = null;
    lehrerID = new Vector_1.Vector();
    wochenstunden = 0;
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.enm.ENMLerngruppe'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new ENMLerngruppe();
        if (typeof obj.id === "undefined")
            throw new Error('invalid json format, missing attribute id');
        result.id = obj.id;
        if (typeof obj.kID === "undefined")
            throw new Error('invalid json format, missing attribute kID');
        result.kID = obj.kID;
        if (typeof obj.fachID === "undefined")
            throw new Error('invalid json format, missing attribute fachID');
        result.fachID = obj.fachID;
        result.kursartID = typeof obj.kursartID === "undefined" ? null : obj.kursartID;
        result.bezeichnung = typeof obj.bezeichnung === "undefined" ? null : obj.bezeichnung;
        result.kursartKuerzel = typeof obj.kursartKuerzel === "undefined" ? null : obj.kursartKuerzel;
        result.bilingualeSprache = typeof obj.bilingualeSprache === "undefined" ? null : obj.bilingualeSprache;
        if (!!obj.lehrerID) {
            for (let elem of obj.lehrerID) {
                result.lehrerID?.add(elem);
            }
        }
        if (typeof obj.wochenstunden === "undefined")
            throw new Error('invalid json format, missing attribute wochenstunden');
        result.wochenstunden = obj.wochenstunden;
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"id" : ' + obj.id + ',';
        result += '"kID" : ' + obj.kID + ',';
        result += '"fachID" : ' + obj.fachID + ',';
        result += '"kursartID" : ' + ((!obj.kursartID) ? 'null' : obj.kursartID.valueOf()) + ',';
        result += '"bezeichnung" : ' + ((!obj.bezeichnung) ? 'null' : '"' + obj.bezeichnung.valueOf() + '"') + ',';
        result += '"kursartKuerzel" : ' + ((!obj.kursartKuerzel) ? 'null' : '"' + obj.kursartKuerzel.valueOf() + '"') + ',';
        result += '"bilingualeSprache" : ' + ((!obj.bilingualeSprache) ? 'null' : '"' + obj.bilingualeSprache.valueOf() + '"') + ',';
        if (!obj.lehrerID) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.lehrerID.size(); i++) {
                let elem = obj.lehrerID.get(i);
                result += elem;
                if (i < obj.lehrerID.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result += '"wochenstunden" : ' + obj.wochenstunden + ',';
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.id !== "undefined") {
            result += '"id" : ' + obj.id + ',';
        }
        if (typeof obj.kID !== "undefined") {
            result += '"kID" : ' + obj.kID + ',';
        }
        if (typeof obj.fachID !== "undefined") {
            result += '"fachID" : ' + obj.fachID + ',';
        }
        if (typeof obj.kursartID !== "undefined") {
            result += '"kursartID" : ' + ((!obj.kursartID) ? 'null' : obj.kursartID.valueOf()) + ',';
        }
        if (typeof obj.bezeichnung !== "undefined") {
            result += '"bezeichnung" : ' + ((!obj.bezeichnung) ? 'null' : '"' + obj.bezeichnung.valueOf() + '"') + ',';
        }
        if (typeof obj.kursartKuerzel !== "undefined") {
            result += '"kursartKuerzel" : ' + ((!obj.kursartKuerzel) ? 'null' : '"' + obj.kursartKuerzel.valueOf() + '"') + ',';
        }
        if (typeof obj.bilingualeSprache !== "undefined") {
            result += '"bilingualeSprache" : ' + ((!obj.bilingualeSprache) ? 'null' : '"' + obj.bilingualeSprache.valueOf() + '"') + ',';
        }
        if (typeof obj.lehrerID !== "undefined") {
            if (!obj.lehrerID) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.lehrerID.size(); i++) {
                    let elem = obj.lehrerID.get(i);
                    result += elem;
                    if (i < obj.lehrerID.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        if (typeof obj.wochenstunden !== "undefined") {
            result += '"wochenstunden" : ' + obj.wochenstunden + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.ENMLerngruppe = ENMLerngruppe;
function cast_de_nrw_schule_svws_core_data_enm_ENMLerngruppe(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_enm_ENMLerngruppe = cast_de_nrw_schule_svws_core_data_enm_ENMLerngruppe;
//# sourceMappingURL=ENMLerngruppe.js.map