import { JavaObject } from '../../../java/lang/JavaObject';
import { ENMLeistung } from '../../../core/data/enm/ENMLeistung';
import { ENMLernabschnitt } from '../../../core/data/enm/ENMLernabschnitt';
import { ENMLeistungBemerkungen } from '../../../core/data/enm/ENMLeistungBemerkungen';
import { ENMZP10 } from '../../../core/data/enm/ENMZP10';
import { ENMBKAbschluss } from '../../../core/data/enm/ENMBKAbschluss';
import { Vector } from '../../../java/util/Vector';
import { ENMSprachenfolge } from '../../../core/data/enm/ENMSprachenfolge';
export declare class ENMSchueler extends JavaObject {
    id: number;
    jahrgangID: number;
    klasseID: number;
    nachname: String | null;
    vorname: String | null;
    geschlecht: String | null;
    bilingualeSprache: String | null;
    istZieldifferent: boolean;
    istDaZFoerderung: boolean;
    sprachenfolge: Vector<ENMSprachenfolge>;
    lernabschnitt: ENMLernabschnitt;
    readonly leistungsdaten: Vector<ENMLeistung>;
    bemerkungen: ENMLeistungBemerkungen | null;
    zp10: ENMZP10 | null;
    bkabschluss: ENMBKAbschluss | null;
    constructor();
    isTranspiledInstanceOf(name: string): boolean;
    static transpilerFromJSON(json: string): ENMSchueler;
    static transpilerToJSON(obj: ENMSchueler): string;
    static transpilerToJSONPatch(obj: Partial<ENMSchueler>): string;
}
export declare function cast_de_nrw_schule_svws_core_data_enm_ENMSchueler(obj: unknown): ENMSchueler;
