"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_enm_ENMSchueler = exports.ENMSchueler = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const ENMLeistung_1 = require("../../../core/data/enm/ENMLeistung");
const ENMLernabschnitt_1 = require("../../../core/data/enm/ENMLernabschnitt");
const ENMLeistungBemerkungen_1 = require("../../../core/data/enm/ENMLeistungBemerkungen");
const ENMZP10_1 = require("../../../core/data/enm/ENMZP10");
const ENMBKAbschluss_1 = require("../../../core/data/enm/ENMBKAbschluss");
const Vector_1 = require("../../../java/util/Vector");
const ENMSprachenfolge_1 = require("../../../core/data/enm/ENMSprachenfolge");
class ENMSchueler extends JavaObject_1.JavaObject {
    id = 0;
    jahrgangID = 0;
    klasseID = 0;
    nachname = null;
    vorname = null;
    geschlecht = null;
    bilingualeSprache = null;
    istZieldifferent = false;
    istDaZFoerderung = false;
    sprachenfolge = new Vector_1.Vector();
    lernabschnitt = new ENMLernabschnitt_1.ENMLernabschnitt();
    leistungsdaten = new Vector_1.Vector();
    bemerkungen = null;
    zp10 = null;
    bkabschluss = null;
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.enm.ENMSchueler'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new ENMSchueler();
        if (typeof obj.id === "undefined")
            throw new Error('invalid json format, missing attribute id');
        result.id = obj.id;
        if (typeof obj.jahrgangID === "undefined")
            throw new Error('invalid json format, missing attribute jahrgangID');
        result.jahrgangID = obj.jahrgangID;
        if (typeof obj.klasseID === "undefined")
            throw new Error('invalid json format, missing attribute klasseID');
        result.klasseID = obj.klasseID;
        result.nachname = typeof obj.nachname === "undefined" ? null : obj.nachname;
        result.vorname = typeof obj.vorname === "undefined" ? null : obj.vorname;
        result.geschlecht = typeof obj.geschlecht === "undefined" ? null : obj.geschlecht;
        result.bilingualeSprache = typeof obj.bilingualeSprache === "undefined" ? null : obj.bilingualeSprache;
        if (typeof obj.istZieldifferent === "undefined")
            throw new Error('invalid json format, missing attribute istZieldifferent');
        result.istZieldifferent = obj.istZieldifferent;
        if (typeof obj.istDaZFoerderung === "undefined")
            throw new Error('invalid json format, missing attribute istDaZFoerderung');
        result.istDaZFoerderung = obj.istDaZFoerderung;
        if (!!obj.sprachenfolge) {
            for (let elem of obj.sprachenfolge) {
                result.sprachenfolge?.add(ENMSprachenfolge_1.ENMSprachenfolge.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        if (typeof obj.lernabschnitt === "undefined")
            throw new Error('invalid json format, missing attribute lernabschnitt');
        result.lernabschnitt = ENMLernabschnitt_1.ENMLernabschnitt.transpilerFromJSON(JSON.stringify(obj.lernabschnitt));
        if (!!obj.leistungsdaten) {
            for (let elem of obj.leistungsdaten) {
                result.leistungsdaten?.add(ENMLeistung_1.ENMLeistung.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        result.bemerkungen = typeof obj.bemerkungen === "undefined" ? null : ENMLeistungBemerkungen_1.ENMLeistungBemerkungen.transpilerFromJSON(JSON.stringify(obj.bemerkungen));
        result.zp10 = typeof obj.zp10 === "undefined" ? null : ENMZP10_1.ENMZP10.transpilerFromJSON(JSON.stringify(obj.zp10));
        result.bkabschluss = typeof obj.bkabschluss === "undefined" ? null : ENMBKAbschluss_1.ENMBKAbschluss.transpilerFromJSON(JSON.stringify(obj.bkabschluss));
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"id" : ' + obj.id + ',';
        result += '"jahrgangID" : ' + obj.jahrgangID + ',';
        result += '"klasseID" : ' + obj.klasseID + ',';
        result += '"nachname" : ' + ((!obj.nachname) ? 'null' : '"' + obj.nachname.valueOf() + '"') + ',';
        result += '"vorname" : ' + ((!obj.vorname) ? 'null' : '"' + obj.vorname.valueOf() + '"') + ',';
        result += '"geschlecht" : ' + ((!obj.geschlecht) ? 'null' : '"' + obj.geschlecht.valueOf() + '"') + ',';
        result += '"bilingualeSprache" : ' + ((!obj.bilingualeSprache) ? 'null' : '"' + obj.bilingualeSprache.valueOf() + '"') + ',';
        result += '"istZieldifferent" : ' + obj.istZieldifferent + ',';
        result += '"istDaZFoerderung" : ' + obj.istDaZFoerderung + ',';
        if (!obj.sprachenfolge) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.sprachenfolge.size(); i++) {
                let elem = obj.sprachenfolge.get(i);
                result += ENMSprachenfolge_1.ENMSprachenfolge.transpilerToJSON(elem);
                if (i < obj.sprachenfolge.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result += '"lernabschnitt" : ' + ENMLernabschnitt_1.ENMLernabschnitt.transpilerToJSON(obj.lernabschnitt) + ',';
        if (!obj.leistungsdaten) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.leistungsdaten.size(); i++) {
                let elem = obj.leistungsdaten.get(i);
                result += ENMLeistung_1.ENMLeistung.transpilerToJSON(elem);
                if (i < obj.leistungsdaten.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result += '"bemerkungen" : ' + ((!obj.bemerkungen) ? 'null' : ENMLeistungBemerkungen_1.ENMLeistungBemerkungen.transpilerToJSON(obj.bemerkungen)) + ',';
        result += '"zp10" : ' + ((!obj.zp10) ? 'null' : ENMZP10_1.ENMZP10.transpilerToJSON(obj.zp10)) + ',';
        result += '"bkabschluss" : ' + ((!obj.bkabschluss) ? 'null' : ENMBKAbschluss_1.ENMBKAbschluss.transpilerToJSON(obj.bkabschluss)) + ',';
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.id !== "undefined") {
            result += '"id" : ' + obj.id + ',';
        }
        if (typeof obj.jahrgangID !== "undefined") {
            result += '"jahrgangID" : ' + obj.jahrgangID + ',';
        }
        if (typeof obj.klasseID !== "undefined") {
            result += '"klasseID" : ' + obj.klasseID + ',';
        }
        if (typeof obj.nachname !== "undefined") {
            result += '"nachname" : ' + ((!obj.nachname) ? 'null' : '"' + obj.nachname.valueOf() + '"') + ',';
        }
        if (typeof obj.vorname !== "undefined") {
            result += '"vorname" : ' + ((!obj.vorname) ? 'null' : '"' + obj.vorname.valueOf() + '"') + ',';
        }
        if (typeof obj.geschlecht !== "undefined") {
            result += '"geschlecht" : ' + ((!obj.geschlecht) ? 'null' : '"' + obj.geschlecht.valueOf() + '"') + ',';
        }
        if (typeof obj.bilingualeSprache !== "undefined") {
            result += '"bilingualeSprache" : ' + ((!obj.bilingualeSprache) ? 'null' : '"' + obj.bilingualeSprache.valueOf() + '"') + ',';
        }
        if (typeof obj.istZieldifferent !== "undefined") {
            result += '"istZieldifferent" : ' + obj.istZieldifferent + ',';
        }
        if (typeof obj.istDaZFoerderung !== "undefined") {
            result += '"istDaZFoerderung" : ' + obj.istDaZFoerderung + ',';
        }
        if (typeof obj.sprachenfolge !== "undefined") {
            if (!obj.sprachenfolge) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.sprachenfolge.size(); i++) {
                    let elem = obj.sprachenfolge.get(i);
                    result += ENMSprachenfolge_1.ENMSprachenfolge.transpilerToJSON(elem);
                    if (i < obj.sprachenfolge.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        if (typeof obj.lernabschnitt !== "undefined") {
            result += '"lernabschnitt" : ' + ENMLernabschnitt_1.ENMLernabschnitt.transpilerToJSON(obj.lernabschnitt) + ',';
        }
        if (typeof obj.leistungsdaten !== "undefined") {
            if (!obj.leistungsdaten) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.leistungsdaten.size(); i++) {
                    let elem = obj.leistungsdaten.get(i);
                    result += ENMLeistung_1.ENMLeistung.transpilerToJSON(elem);
                    if (i < obj.leistungsdaten.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        if (typeof obj.bemerkungen !== "undefined") {
            result += '"bemerkungen" : ' + ((!obj.bemerkungen) ? 'null' : ENMLeistungBemerkungen_1.ENMLeistungBemerkungen.transpilerToJSON(obj.bemerkungen)) + ',';
        }
        if (typeof obj.zp10 !== "undefined") {
            result += '"zp10" : ' + ((!obj.zp10) ? 'null' : ENMZP10_1.ENMZP10.transpilerToJSON(obj.zp10)) + ',';
        }
        if (typeof obj.bkabschluss !== "undefined") {
            result += '"bkabschluss" : ' + ((!obj.bkabschluss) ? 'null' : ENMBKAbschluss_1.ENMBKAbschluss.transpilerToJSON(obj.bkabschluss)) + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.ENMSchueler = ENMSchueler;
function cast_de_nrw_schule_svws_core_data_enm_ENMSchueler(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_enm_ENMSchueler = cast_de_nrw_schule_svws_core_data_enm_ENMSchueler;
//# sourceMappingURL=ENMSchueler.js.map