"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_enm_ENMSprachenfolge = exports.ENMSprachenfolge = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class ENMSprachenfolge extends JavaObject_1.JavaObject {
    sprache = null;
    fachID = 0;
    fachKuerzel = null;
    reihenfolge = 0;
    belegungVonJahrgang = 0;
    belegungVonAbschnitt = 0;
    belegungBisJahrgang = null;
    belegungBisAbschnitt = null;
    referenzniveau = null;
    belegungSekI = null;
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.enm.ENMSprachenfolge'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new ENMSprachenfolge();
        result.sprache = typeof obj.sprache === "undefined" ? null : obj.sprache;
        if (typeof obj.fachID === "undefined")
            throw new Error('invalid json format, missing attribute fachID');
        result.fachID = obj.fachID;
        result.fachKuerzel = typeof obj.fachKuerzel === "undefined" ? null : obj.fachKuerzel;
        if (typeof obj.reihenfolge === "undefined")
            throw new Error('invalid json format, missing attribute reihenfolge');
        result.reihenfolge = obj.reihenfolge;
        if (typeof obj.belegungVonJahrgang === "undefined")
            throw new Error('invalid json format, missing attribute belegungVonJahrgang');
        result.belegungVonJahrgang = obj.belegungVonJahrgang;
        if (typeof obj.belegungVonAbschnitt === "undefined")
            throw new Error('invalid json format, missing attribute belegungVonAbschnitt');
        result.belegungVonAbschnitt = obj.belegungVonAbschnitt;
        result.belegungBisJahrgang = typeof obj.belegungBisJahrgang === "undefined" ? null : obj.belegungBisJahrgang;
        result.belegungBisAbschnitt = typeof obj.belegungBisAbschnitt === "undefined" ? null : obj.belegungBisAbschnitt;
        result.referenzniveau = typeof obj.referenzniveau === "undefined" ? null : obj.referenzniveau;
        result.belegungSekI = typeof obj.belegungSekI === "undefined" ? null : obj.belegungSekI;
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"sprache" : ' + ((!obj.sprache) ? 'null' : '"' + obj.sprache.valueOf() + '"') + ',';
        result += '"fachID" : ' + obj.fachID + ',';
        result += '"fachKuerzel" : ' + ((!obj.fachKuerzel) ? 'null' : '"' + obj.fachKuerzel.valueOf() + '"') + ',';
        result += '"reihenfolge" : ' + obj.reihenfolge + ',';
        result += '"belegungVonJahrgang" : ' + obj.belegungVonJahrgang + ',';
        result += '"belegungVonAbschnitt" : ' + obj.belegungVonAbschnitt + ',';
        result += '"belegungBisJahrgang" : ' + ((!obj.belegungBisJahrgang) ? 'null' : obj.belegungBisJahrgang.valueOf()) + ',';
        result += '"belegungBisAbschnitt" : ' + ((!obj.belegungBisAbschnitt) ? 'null' : obj.belegungBisAbschnitt.valueOf()) + ',';
        result += '"referenzniveau" : ' + ((!obj.referenzniveau) ? 'null' : '"' + obj.referenzniveau.valueOf() + '"') + ',';
        result += '"belegungSekI" : ' + ((!obj.belegungSekI) ? 'null' : obj.belegungSekI.valueOf()) + ',';
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.sprache !== "undefined") {
            result += '"sprache" : ' + ((!obj.sprache) ? 'null' : '"' + obj.sprache.valueOf() + '"') + ',';
        }
        if (typeof obj.fachID !== "undefined") {
            result += '"fachID" : ' + obj.fachID + ',';
        }
        if (typeof obj.fachKuerzel !== "undefined") {
            result += '"fachKuerzel" : ' + ((!obj.fachKuerzel) ? 'null' : '"' + obj.fachKuerzel.valueOf() + '"') + ',';
        }
        if (typeof obj.reihenfolge !== "undefined") {
            result += '"reihenfolge" : ' + obj.reihenfolge + ',';
        }
        if (typeof obj.belegungVonJahrgang !== "undefined") {
            result += '"belegungVonJahrgang" : ' + obj.belegungVonJahrgang + ',';
        }
        if (typeof obj.belegungVonAbschnitt !== "undefined") {
            result += '"belegungVonAbschnitt" : ' + obj.belegungVonAbschnitt + ',';
        }
        if (typeof obj.belegungBisJahrgang !== "undefined") {
            result += '"belegungBisJahrgang" : ' + ((!obj.belegungBisJahrgang) ? 'null' : obj.belegungBisJahrgang.valueOf()) + ',';
        }
        if (typeof obj.belegungBisAbschnitt !== "undefined") {
            result += '"belegungBisAbschnitt" : ' + ((!obj.belegungBisAbschnitt) ? 'null' : obj.belegungBisAbschnitt.valueOf()) + ',';
        }
        if (typeof obj.referenzniveau !== "undefined") {
            result += '"referenzniveau" : ' + ((!obj.referenzniveau) ? 'null' : '"' + obj.referenzniveau.valueOf() + '"') + ',';
        }
        if (typeof obj.belegungSekI !== "undefined") {
            result += '"belegungSekI" : ' + ((!obj.belegungSekI) ? 'null' : obj.belegungSekI.valueOf()) + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.ENMSprachenfolge = ENMSprachenfolge;
function cast_de_nrw_schule_svws_core_data_enm_ENMSprachenfolge(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_enm_ENMSprachenfolge = cast_de_nrw_schule_svws_core_data_enm_ENMSprachenfolge;
//# sourceMappingURL=ENMSprachenfolge.js.map