import { JavaObject } from '../../../java/lang/JavaObject';
import { AbiturFachbelegung } from '../../../core/data/gost/AbiturFachbelegung';
import { Vector } from '../../../java/util/Vector';
import { Sprachendaten } from '../../../core/data/Sprachendaten';
export declare class Abiturdaten extends JavaObject {
    schuelerID: number;
    abiturjahr: number;
    schuljahrAbitur: number;
    readonly bewertetesHalbjahr: Array<boolean>;
    readonly fachbelegungen: Vector<AbiturFachbelegung>;
    sprachendaten: Sprachendaten;
    bilingualeSprache: String | null;
    sek1Fremdsprache2ManuellGeprueft: boolean;
    muttersprachenpruefungEndeEF: boolean;
    latinum: boolean;
    kleinesLatinum: boolean;
    graecum: boolean;
    hebraicum: boolean;
    block1FehlstundenGesamt: number;
    block1FehlstundenUnentschuldigt: number;
    projektKursThema: String | null;
    projektkursLeitfach1Kuerzel: String | null;
    projektkursLeitfach2Kuerzel: String | null;
    besondereLernleistung: String | null;
    besondereLernleistungNotenKuerzel: String | null;
    besondereLernleistungThema: String | null;
    block1AnzahlKurse: Number | null;
    block1DefiziteGesamt: Number | null;
    block1DefiziteLK: Number | null;
    block1PunktSummeGK: Number | null;
    block1PunktSummeLK: Number | null;
    block1PunktSummeNormiert: Number | null;
    block1NotenpunkteDurchschnitt: Number | null;
    block1Zulassung: Boolean | null;
    freiwilligerRuecktritt: boolean;
    block2DefiziteGesamt: Number | null;
    block2DefiziteLK: Number | null;
    block2PunktSumme: Number | null;
    gesamtPunkte: Number | null;
    gesamtPunkteVerbesserung: Number | null;
    gesamtPunkteVerschlechterung: Number | null;
    pruefungBestanden: Boolean | null;
    note: String | null;
    constructor();
    isTranspiledInstanceOf(name: string): boolean;
    static transpilerFromJSON(json: string): Abiturdaten;
    static transpilerToJSON(obj: Abiturdaten): string;
    static transpilerToJSONPatch(obj: Partial<Abiturdaten>): string;
}
export declare function cast_de_nrw_schule_svws_core_data_gost_Abiturdaten(obj: unknown): Abiturdaten;
