"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_gost_GostJahrgangsdaten = exports.GostJahrgangsdaten = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const GostBeratungslehrer_1 = require("../../../core/data/gost/GostBeratungslehrer");
const Vector_1 = require("../../../java/util/Vector");
class GostJahrgangsdaten extends JavaObject_1.JavaObject {
    abiturjahr = null;
    jahrgang = null;
    bezeichnung = null;
    istAbgeschlossen = false;
    textBeratungsbogen = null;
    textMailversand = null;
    beginnZusatzkursGE = null;
    beginnZusatzkursSW = null;
    beratungslehrer = new Vector_1.Vector();
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.gost.GostJahrgangsdaten'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new GostJahrgangsdaten();
        result.abiturjahr = typeof obj.abiturjahr === "undefined" ? null : obj.abiturjahr;
        result.jahrgang = typeof obj.jahrgang === "undefined" ? null : obj.jahrgang;
        result.bezeichnung = typeof obj.bezeichnung === "undefined" ? null : obj.bezeichnung;
        if (typeof obj.istAbgeschlossen === "undefined")
            throw new Error('invalid json format, missing attribute istAbgeschlossen');
        result.istAbgeschlossen = obj.istAbgeschlossen;
        result.textBeratungsbogen = typeof obj.textBeratungsbogen === "undefined" ? null : obj.textBeratungsbogen;
        result.textMailversand = typeof obj.textMailversand === "undefined" ? null : obj.textMailversand;
        result.beginnZusatzkursGE = typeof obj.beginnZusatzkursGE === "undefined" ? null : obj.beginnZusatzkursGE;
        result.beginnZusatzkursSW = typeof obj.beginnZusatzkursSW === "undefined" ? null : obj.beginnZusatzkursSW;
        if (!!obj.beratungslehrer) {
            for (let elem of obj.beratungslehrer) {
                result.beratungslehrer?.add(GostBeratungslehrer_1.GostBeratungslehrer.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"abiturjahr" : ' + ((!obj.abiturjahr) ? 'null' : obj.abiturjahr.valueOf()) + ',';
        result += '"jahrgang" : ' + ((!obj.jahrgang) ? 'null' : '"' + obj.jahrgang.valueOf() + '"') + ',';
        result += '"bezeichnung" : ' + ((!obj.bezeichnung) ? 'null' : '"' + obj.bezeichnung.valueOf() + '"') + ',';
        result += '"istAbgeschlossen" : ' + obj.istAbgeschlossen + ',';
        result += '"textBeratungsbogen" : ' + ((!obj.textBeratungsbogen) ? 'null' : '"' + obj.textBeratungsbogen.valueOf() + '"') + ',';
        result += '"textMailversand" : ' + ((!obj.textMailversand) ? 'null' : '"' + obj.textMailversand.valueOf() + '"') + ',';
        result += '"beginnZusatzkursGE" : ' + ((!obj.beginnZusatzkursGE) ? 'null' : '"' + obj.beginnZusatzkursGE.valueOf() + '"') + ',';
        result += '"beginnZusatzkursSW" : ' + ((!obj.beginnZusatzkursSW) ? 'null' : '"' + obj.beginnZusatzkursSW.valueOf() + '"') + ',';
        if (!obj.beratungslehrer) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.beratungslehrer.size(); i++) {
                let elem = obj.beratungslehrer.get(i);
                result += GostBeratungslehrer_1.GostBeratungslehrer.transpilerToJSON(elem);
                if (i < obj.beratungslehrer.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.abiturjahr !== "undefined") {
            result += '"abiturjahr" : ' + ((!obj.abiturjahr) ? 'null' : obj.abiturjahr.valueOf()) + ',';
        }
        if (typeof obj.jahrgang !== "undefined") {
            result += '"jahrgang" : ' + ((!obj.jahrgang) ? 'null' : '"' + obj.jahrgang.valueOf() + '"') + ',';
        }
        if (typeof obj.bezeichnung !== "undefined") {
            result += '"bezeichnung" : ' + ((!obj.bezeichnung) ? 'null' : '"' + obj.bezeichnung.valueOf() + '"') + ',';
        }
        if (typeof obj.istAbgeschlossen !== "undefined") {
            result += '"istAbgeschlossen" : ' + obj.istAbgeschlossen + ',';
        }
        if (typeof obj.textBeratungsbogen !== "undefined") {
            result += '"textBeratungsbogen" : ' + ((!obj.textBeratungsbogen) ? 'null' : '"' + obj.textBeratungsbogen.valueOf() + '"') + ',';
        }
        if (typeof obj.textMailversand !== "undefined") {
            result += '"textMailversand" : ' + ((!obj.textMailversand) ? 'null' : '"' + obj.textMailversand.valueOf() + '"') + ',';
        }
        if (typeof obj.beginnZusatzkursGE !== "undefined") {
            result += '"beginnZusatzkursGE" : ' + ((!obj.beginnZusatzkursGE) ? 'null' : '"' + obj.beginnZusatzkursGE.valueOf() + '"') + ',';
        }
        if (typeof obj.beginnZusatzkursSW !== "undefined") {
            result += '"beginnZusatzkursSW" : ' + ((!obj.beginnZusatzkursSW) ? 'null' : '"' + obj.beginnZusatzkursSW.valueOf() + '"') + ',';
        }
        if (typeof obj.beratungslehrer !== "undefined") {
            if (!obj.beratungslehrer) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.beratungslehrer.size(); i++) {
                    let elem = obj.beratungslehrer.get(i);
                    result += GostBeratungslehrer_1.GostBeratungslehrer.transpilerToJSON(elem);
                    if (i < obj.beratungslehrer.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.GostJahrgangsdaten = GostJahrgangsdaten;
function cast_de_nrw_schule_svws_core_data_gost_GostJahrgangsdaten(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_gost_GostJahrgangsdaten = cast_de_nrw_schule_svws_core_data_gost_GostJahrgangsdaten;
//# sourceMappingURL=GostJahrgangsdaten.js.map