"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_gost_GostLeistungenFachwahl = exports.GostLeistungenFachwahl = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const GostFach_1 = require("../../../core/data/gost/GostFach");
const Vector_1 = require("../../../java/util/Vector");
const GostLeistungenFachbelegung_1 = require("../../../core/data/gost/GostLeistungenFachbelegung");
class GostLeistungenFachwahl extends JavaObject_1.JavaObject {
    fach = new GostFach_1.GostFach();
    abiturfach = null;
    istFSNeu = false;
    belegungen = new Vector_1.Vector();
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.gost.GostLeistungenFachwahl'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new GostLeistungenFachwahl();
        result.fach = typeof obj.fach === "undefined" ? null : GostFach_1.GostFach.transpilerFromJSON(JSON.stringify(obj.fach));
        result.abiturfach = typeof obj.abiturfach === "undefined" ? null : obj.abiturfach;
        if (typeof obj.istFSNeu === "undefined")
            throw new Error('invalid json format, missing attribute istFSNeu');
        result.istFSNeu = obj.istFSNeu;
        if (!!obj.belegungen) {
            for (let elem of obj.belegungen) {
                result.belegungen?.add(GostLeistungenFachbelegung_1.GostLeistungenFachbelegung.transpilerFromJSON(JSON.stringify(elem)));
            }
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"fach" : ' + ((!obj.fach) ? 'null' : GostFach_1.GostFach.transpilerToJSON(obj.fach)) + ',';
        result += '"abiturfach" : ' + ((!obj.abiturfach) ? 'null' : obj.abiturfach.valueOf()) + ',';
        result += '"istFSNeu" : ' + obj.istFSNeu + ',';
        if (!obj.belegungen) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.belegungen.size(); i++) {
                let elem = obj.belegungen.get(i);
                result += GostLeistungenFachbelegung_1.GostLeistungenFachbelegung.transpilerToJSON(elem);
                if (i < obj.belegungen.size() - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.fach !== "undefined") {
            result += '"fach" : ' + ((!obj.fach) ? 'null' : GostFach_1.GostFach.transpilerToJSON(obj.fach)) + ',';
        }
        if (typeof obj.abiturfach !== "undefined") {
            result += '"abiturfach" : ' + ((!obj.abiturfach) ? 'null' : obj.abiturfach.valueOf()) + ',';
        }
        if (typeof obj.istFSNeu !== "undefined") {
            result += '"istFSNeu" : ' + obj.istFSNeu + ',';
        }
        if (typeof obj.belegungen !== "undefined") {
            if (!obj.belegungen) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < obj.belegungen.size(); i++) {
                    let elem = obj.belegungen.get(i);
                    result += GostLeistungenFachbelegung_1.GostLeistungenFachbelegung.transpilerToJSON(elem);
                    if (i < obj.belegungen.size() - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.GostLeistungenFachwahl = GostLeistungenFachwahl;
function cast_de_nrw_schule_svws_core_data_gost_GostLeistungenFachwahl(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_gost_GostLeistungenFachwahl = cast_de_nrw_schule_svws_core_data_gost_GostLeistungenFachwahl;
//# sourceMappingURL=GostLeistungenFachwahl.js.map