"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_data_gost_GostStatistikFachwahl = exports.GostStatistikFachwahl = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const GostStatistikFachwahlHalbjahr_1 = require("../../../core/data/gost/GostStatistikFachwahlHalbjahr");
class GostStatistikFachwahl extends JavaObject_1.JavaObject {
    abiturjahr = 0;
    id = 0;
    kuerzel = null;
    bezeichnung = null;
    kuerzelStatistik = null;
    fachwahlen = Array(6).fill(null);
    constructor() {
        super();
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.data.gost.GostStatistikFachwahl'].includes(name);
    }
    static transpilerFromJSON(json) {
        const obj = JSON.parse(json);
        const result = new GostStatistikFachwahl();
        if (typeof obj.abiturjahr === "undefined")
            throw new Error('invalid json format, missing attribute abiturjahr');
        result.abiturjahr = obj.abiturjahr;
        if (typeof obj.id === "undefined")
            throw new Error('invalid json format, missing attribute id');
        result.id = obj.id;
        result.kuerzel = typeof obj.kuerzel === "undefined" ? null : obj.kuerzel;
        result.bezeichnung = typeof obj.bezeichnung === "undefined" ? null : obj.bezeichnung;
        result.kuerzelStatistik = typeof obj.kuerzelStatistik === "undefined" ? null : obj.kuerzelStatistik;
        for (let i = 0; i < obj.fachwahlen.length; i++) {
            result.fachwahlen[i] = (GostStatistikFachwahlHalbjahr_1.GostStatistikFachwahlHalbjahr.transpilerFromJSON(JSON.stringify(obj.fachwahlen[i])));
        }
        return result;
    }
    static transpilerToJSON(obj) {
        let result = '{';
        result += '"abiturjahr" : ' + obj.abiturjahr + ',';
        result += '"id" : ' + obj.id + ',';
        result += '"kuerzel" : ' + ((!obj.kuerzel) ? 'null' : '"' + obj.kuerzel.valueOf() + '"') + ',';
        result += '"bezeichnung" : ' + ((!obj.bezeichnung) ? 'null' : '"' + obj.bezeichnung.valueOf() + '"') + ',';
        result += '"kuerzelStatistik" : ' + ((!obj.kuerzelStatistik) ? 'null' : '"' + obj.kuerzelStatistik.valueOf() + '"') + ',';
        if (!obj.fachwahlen) {
            result += '[]';
        }
        else {
            result += '[ ';
            for (let i = 0; i < obj.fachwahlen.length; i++) {
                let elem = obj.fachwahlen[i];
                result += GostStatistikFachwahlHalbjahr_1.GostStatistikFachwahlHalbjahr.transpilerToJSON(elem);
                if (i < obj.fachwahlen.length - 1)
                    result += ',';
            }
            result += ' ]' + ',';
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
    static transpilerToJSONPatch(obj) {
        let result = '{';
        if (typeof obj.abiturjahr !== "undefined") {
            result += '"abiturjahr" : ' + obj.abiturjahr + ',';
        }
        if (typeof obj.id !== "undefined") {
            result += '"id" : ' + obj.id + ',';
        }
        if (typeof obj.kuerzel !== "undefined") {
            result += '"kuerzel" : ' + ((!obj.kuerzel) ? 'null' : '"' + obj.kuerzel.valueOf() + '"') + ',';
        }
        if (typeof obj.bezeichnung !== "undefined") {
            result += '"bezeichnung" : ' + ((!obj.bezeichnung) ? 'null' : '"' + obj.bezeichnung.valueOf() + '"') + ',';
        }
        if (typeof obj.kuerzelStatistik !== "undefined") {
            result += '"kuerzelStatistik" : ' + ((!obj.kuerzelStatistik) ? 'null' : '"' + obj.kuerzelStatistik.valueOf() + '"') + ',';
        }
        if (typeof obj.fachwahlen !== "undefined") {
            let a = obj.fachwahlen;
            if (!a) {
                result += '[]';
            }
            else {
                result += '[ ';
                for (let i = 0; i < a.length; i++) {
                    let elem = a[i];
                    result += GostStatistikFachwahlHalbjahr_1.GostStatistikFachwahlHalbjahr.transpilerToJSON(elem);
                    if (i < a.length - 1)
                        result += ',';
                }
                result += ' ]' + ',';
            }
        }
        result = result.slice(0, -1);
        result += '}';
        return result;
    }
}
exports.GostStatistikFachwahl = GostStatistikFachwahl;
function cast_de_nrw_schule_svws_core_data_gost_GostStatistikFachwahl(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_data_gost_GostStatistikFachwahl = cast_de_nrw_schule_svws_core_data_gost_GostStatistikFachwahl;
//# sourceMappingURL=GostStatistikFachwahl.js.map