import { JavaObject } from '../../java/lang/JavaObject';
import { Comparable } from '../../java/lang/Comparable';
export declare class SprachBelegungSekI extends JavaObject implements Comparable<SprachBelegungSekI | null> {
    static readonly NICHT_BELEGT: SprachBelegungSekI;
    static readonly MIND_2_JAHRE: SprachBelegungSekI;
    static readonly MIND_4_JAHRE: SprachBelegungSekI;
    static readonly AB_JAHRGANG_5: SprachBelegungSekI;
    readonly dauer: number;
    /**
     * Erstellt einen neuen enum-Wert mit der angegebenen Dauer der Sprachbelegung.
     *
     * @param dauer   die Dauer der Sprachbelegung in der Sek I
     */
    private constructor();
    /**
     * Ermittelt die Spachbelegung in der Sek I anhand des übergebenen Jahrgangs.
     * WICHTIG: Sollte ein Schüler sich im G8-Bildungsgang bewegen, so wird die Dauer
     * mit 6 Jahren hier nicht korrekt zugeordnet.
     *
     * @param ASDJahrgang der Jahrgang in welchem mit der Sprache begonnen wurde
     *
     * @return die Sprachbelegung in der Sek I
     */
    static getByASDJahrgang(ASDJahrgang: String | null): SprachBelegungSekI;
    /**
     * Ermittelt die Spachbelegung in der Sek I anhand der übergebenen Dauer der Belegung in der Sek I.
     * WICHTIG: Sollte ein Schüler sich im G8-Bildungsgang bewegen, so wird die Dauer
     * mit 6 Jahren hier nicht korrekt zugeordnet.
     *
     * @param dauer   die Dauer in vollen Jahren bei der Sprachbelegung in der Sek I
     *
     * @return die Sprachbelegung in der Sek I
     */
    static getByDauer(dauer: number): SprachBelegungSekI;
    compareTo(other: SprachBelegungSekI | null): number;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_SprachBelegungSekI(obj: unknown): SprachBelegungSekI;
