import { JavaObject } from '../../java/lang/JavaObject';
export declare class Sprachpruefungniveau extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly NIVEAU_HA9: Sprachpruefungniveau;
    static readonly NIVEAU_HA10: Sprachpruefungniveau;
    static readonly NIVEAU_MSA: Sprachpruefungniveau;
    static readonly NIVEAU_EF: Sprachpruefungniveau;
    static readonly NIVEAU_FHR: Sprachpruefungniveau;
    static readonly NIVEAU_WBK_FF: Sprachpruefungniveau;
    private static _mapID;
    private static _mapBezeichnung;
    readonly id: number;
    readonly bezeichnung: String;
    readonly beschreibung: String;
    readonly gueltigVon: Number | null;
    readonly gueltigBis: Number | null;
    /**
     * Erstellt ein neues Prüfungsniveau dieser Aufzählung.
     *
     * @param id            die ID des Prüfungsniveaus
     * @param bezeichnung   die Bezeichnung des Prüfungsniveaus
     * @param beschreibung  die Beschreibung des Prüfungsniveaus
     * @param gueltigVon	Schuljahr, ab dem das Niveau gültig ist
     * @param gueltigBis	Schuljahr, bis zu dem das Niveau gültig war
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Sprachprüfungsniveaus auf die zugehörigen Sprachprüfungsniveaus
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Sprachprüfungsniveaus auf die zugehörigen Sprachprüfungsniveaus
     */
    private static getMapSprachpruefungniveauByID;
    /**
     * Gibt eine Map von den Bezeichnungen der Sprachprüfungsniveaus auf die zugehörigen Sprachprüfungsniveaus
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Bezeichnungen der Sprachprüfungsniveaus auf die zugehörigen Sprachprüfungsniveaus
     */
    private static getMapSprachpruefungniveauByBezeichnung;
    /**
     * Gibt das Prüfungsniveau für die übergebene ID zurück.
     *
     * @param id   die ID des Prüfungsniveaus
     *
     * @return das Prüfungsniveaus oder null, wenn die ID ungültig ist
     */
    static getByID(id: Number | null): Sprachpruefungniveau | null;
    /**
     * Gibt das Prüfungsniveau für die übergebene Bezeichnung zurück.
     *
     * @param bezeichnung   die Bezeichnung des Prüfungsniveaus
     *
     * @return das Prüfungsniveaus oder null, wenn die Bezeichnung ungültig ist
     */
    static getByBezeichnung(bezeichnung: String | null): Sprachpruefungniveau | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: Sprachpruefungniveau): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<Sprachpruefungniveau>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): Sprachpruefungniveau | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_Sprachpruefungniveau(obj: unknown): Sprachpruefungniveau;
