import { JavaObject } from '../../java/lang/JavaObject';
import { Comparable } from '../../java/lang/Comparable';
export declare class Sprachreferenzniveau extends JavaObject implements Comparable<Sprachreferenzniveau | null> {
    private static mapBezeichnung;
    static readonly A1: Sprachreferenzniveau;
    static readonly A1P: Sprachreferenzniveau;
    static readonly A1A2: Sprachreferenzniveau;
    static readonly A2: Sprachreferenzniveau;
    static readonly A2P: Sprachreferenzniveau;
    static readonly A2B1: Sprachreferenzniveau;
    static readonly B1: Sprachreferenzniveau;
    static readonly B1P: Sprachreferenzniveau;
    static readonly B1B2: Sprachreferenzniveau;
    static readonly B2: Sprachreferenzniveau;
    static readonly B2C1: Sprachreferenzniveau;
    static readonly C1: Sprachreferenzniveau;
    static readonly C2: Sprachreferenzniveau;
    private readonly sortierung;
    readonly bezeichnung: String;
    /**
     *
     * Erstellt ein neues Sprachreferenzniveau dieser Aufzählung.
     *
     * @param sortierung    die Sortierung, welche nur intern für den vergleich von
     *                      Referenzniveaus genutzt wird.
     * @param bezeichnung   die Bezeichnung des Sprachreferenzniveaus
     */
    private constructor();
    /**
     * Gibt das Sprachreferenzniveau für die übergebene Bezeichnung zurück.
     *
     * @param bezeichnung   die Bezeichnung des Sprachreferenzniveaus
     *
     * @return das Sprachreferenzniveau oder null im Fehlerfall
     */
    static getByBezeichnung(bezeichnung: String | null): Sprachreferenzniveau | null;
    compareTo(other: Sprachreferenzniveau | null): number;
    /**
     * Vergleicht dieses Sprachreferenzniveau mit dem Niveau der übergebenen Bezeichnung.
     *
     * @param bezeichnung   die Bezeichnung des anderen Sprachreferenzniveaus
     *
     * @return siehe {@link Sprachreferenzniveau#compareTo(Sprachreferenzniveau)}
     */
    compareTo(bezeichnung: String | null): number;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_Sprachreferenzniveau(obj: unknown): Sprachreferenzniveau;
