import { JavaObject } from '../../../java/lang/JavaObject';
export declare class BenutzerKompetenz extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly KEINE: BenutzerKompetenz;
    static readonly ADMIN: BenutzerKompetenz;
    static readonly SCHUELER_INDIVIDUALDATEN_ANSEHEN: BenutzerKompetenz;
    static readonly SCHUELER_INDIVIDUALDATEN_AENDERN: BenutzerKompetenz;
    static readonly SCHUELER_INDIVIDUALDATEN_LOESCHEN: BenutzerKompetenz;
    static readonly SCHUELER_INDIVIDUALDATEN_VERMERKE_AENDERN: BenutzerKompetenz;
    static readonly SCHUELER_INDIVIDUALDATEN_KAOA_DATEN_AENDERN: BenutzerKompetenz;
    static readonly SCHUELER_LEISTUNGSDATEN_ANSEHEN: BenutzerKompetenz;
    static readonly SCHUELER_LEISTUNGSDATEN_FUNKTIONSBEZOGEN_AENDERN: BenutzerKompetenz;
    static readonly SCHUELER_LEISTUNGSDATEN_ALLE_AENDERN: BenutzerKompetenz;
    static readonly BERICHTE_ALLE_FORMULARE_DRUCKEN: BenutzerKompetenz;
    static readonly BERICHTE_STANDARDFORMULARE_DRUCKEN: BenutzerKompetenz;
    static readonly BERICHTE_AENDERN: BenutzerKompetenz;
    static readonly BERICHTE_LOESCHEN: BenutzerKompetenz;
    static readonly IMPORT_EXPORT_DATEN_IMPORTIEREN: BenutzerKompetenz;
    static readonly IMPORT_EXPORT_SCHUELERDATEN_EXPORTIEREN: BenutzerKompetenz;
    static readonly IMPORT_EXPORT_LEHRERDATEN_EXPORTIEREN: BenutzerKompetenz;
    static readonly IMPORT_EXPORT_SCHNITTSTELLE_SCHILD_NRW: BenutzerKompetenz;
    static readonly IMPORT_EXPORT_ACCESS_DB: BenutzerKompetenz;
    static readonly IMPORT_EXPORT_XML: BenutzerKompetenz;
    static readonly SCHULBEZOGENE_DATEN_ANSEHEN: BenutzerKompetenz;
    static readonly SCHULBEZOGENE_DATEN_AENDERN: BenutzerKompetenz;
    static readonly EXTRAS_BACKUP_DURCHFUEHREN: BenutzerKompetenz;
    static readonly EXTRAS_GELOESCHTE_DATEN_ZURUECKHOLEN: BenutzerKompetenz;
    static readonly EXTRAS_FARBEN_FUER_FACHGRUPPEN_AENDERN: BenutzerKompetenz;
    static readonly EXTRAS_DATEN_AUS_KURS42_IMPORTIEREN: BenutzerKompetenz;
    static readonly EXTRAS_DATEN_PERSONENGRUPPEN_BEARBEITEN: BenutzerKompetenz;
    static readonly KATALOG_EINTRAEGE_ANSEHEN: BenutzerKompetenz;
    static readonly KATALOG_EINTRAEGE_AENDERN: BenutzerKompetenz;
    static readonly KATALOG_EINTRAEGE_LOESCHEN: BenutzerKompetenz;
    static readonly LEHRERDATEN_ANSEHEN: BenutzerKompetenz;
    static readonly LEHRERDATEN_AENDERN: BenutzerKompetenz;
    static readonly LEHRERDATEN_LOESCHEN: BenutzerKompetenz;
    static readonly LEHRERDATEN_DETAILDATEN_ANSEHEN: BenutzerKompetenz;
    static readonly LEHRERDATEN_DETAILDATEN_AENDERN: BenutzerKompetenz;
    static readonly SCHULPFLICHTVERLETZUNG_ANSEHEN: BenutzerKompetenz;
    static readonly SCHULPFLICHTVERLETZUNG_AENDERN: BenutzerKompetenz;
    static readonly SCHULPFLICHTVERLETZUNG_LOESCHEN: BenutzerKompetenz;
    private static readonly _mapID;
    readonly id: number;
    readonly bezeichnungGruppe: String;
    readonly bezeichnung: String;
    /**
     * Erzeugt eine neue Benutzerkompetenz für die Aufzählung.
     *
     * @param id                  die ID der Benutzerkompetenz
     * @param bezeichnungGruppe   die Bezeichnung der Gruppe von Kompetenzen zu dieser diese Benutzerkompetenz gehört
     * @param bezeichnung         die Bezeichnung der Benutzerkompetenz
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Benutzerkompetenzen auf die zugehörigen Benutzerkompetenzen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Benutzerkompetenzen auf die zugehörigen Benutzerkompetenzen
     */
    private static getMapID;
    /**
     *
     * Gibt die Benutzerkompetenz anhand der übergebenen ID zurück.
     *
     * @param id    die ID der Benutzerkompetenz
     *
     * @return die Benutzerkompetenz oder null, falls die ID fehlerhaft ist
     */
    static getByID(id: number): BenutzerKompetenz | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: BenutzerKompetenz): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<BenutzerKompetenz>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): BenutzerKompetenz | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_benutzer_BenutzerKompetenz(obj: unknown): BenutzerKompetenz;
