import { JavaObject } from '../../../java/lang/JavaObject';
export declare class BenutzerTyp extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly ALLGEMEIN: BenutzerTyp;
    static readonly LEHRER: BenutzerTyp;
    static readonly SCHUELER: BenutzerTyp;
    static readonly ERZIEHER: BenutzerTyp;
    readonly id: number;
    readonly bezeichnung: String;
    /**
     * Erzeugt einen neuen Benutzertyp für die Aufzählung.
     *
     * @param id                  die ID des Benutzertyps
     * @param bezeichnung         die Bezeichnung des Benutzertyps
     */
    private constructor();
    /**
     *
     * Gibt den Benutzertyp die Benutzerkompetenz anhand der übergebenen ID zurück.
     *
     * @param id    die ID der Benutzerkompetenz
     *
     * @return die Benutzerkompetenz oder null, falls die ID fehlerhaft ist
     */
    static getByID(id: number): BenutzerTyp | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: BenutzerTyp): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<BenutzerTyp>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): BenutzerTyp | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_benutzer_BenutzerTyp(obj: unknown): BenutzerTyp;
