"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_benutzer_BenutzerTyp = exports.BenutzerTyp = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class BenutzerTyp extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static ALLGEMEIN = new BenutzerTyp("ALLGEMEIN", 0, 0, "Allgemein");
    static LEHRER = new BenutzerTyp("LEHRER", 1, 1, "Lehrer/Personal");
    static SCHUELER = new BenutzerTyp("SCHUELER", 2, 2, "Schüler");
    static ERZIEHER = new BenutzerTyp("ERZIEHER", 3, 3, "Erzieher");
    id;
    bezeichnung;
    /**
     * Erzeugt einen neuen Benutzertyp für die Aufzählung.
     *
     * @param id                  die ID des Benutzertyps
     * @param bezeichnung         die Bezeichnung des Benutzertyps
     */
    constructor(name, ordinal, id, bezeichnung) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        BenutzerTyp.all_values_by_ordinal.push(this);
        BenutzerTyp.all_values_by_name.set(name, this);
        this.id = id;
        this.bezeichnung = bezeichnung;
    }
    /**
     *
     * Gibt den Benutzertyp die Benutzerkompetenz anhand der übergebenen ID zurück.
     *
     * @param id    die ID der Benutzerkompetenz
     *
     * @return die Benutzerkompetenz oder null, falls die ID fehlerhaft ist
     */
    static getByID(id) {
        switch (id) {
            case 0:
                return BenutzerTyp.ALLGEMEIN;
            case 1:
                return BenutzerTyp.LEHRER;
            case 2:
                return BenutzerTyp.SCHUELER;
            case 3:
                return BenutzerTyp.ERZIEHER;
        }
        return null;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof BenutzerTyp))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.benutzer.BenutzerTyp'].includes(name);
    }
}
exports.BenutzerTyp = BenutzerTyp;
function cast_de_nrw_schule_svws_core_types_benutzer_BenutzerTyp(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_benutzer_BenutzerTyp = cast_de_nrw_schule_svws_core_types_benutzer_BenutzerTyp;
//# sourceMappingURL=BenutzerTyp.js.map