"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_ge_GELeistungsdifferenzierteKursart = exports.GELeistungsdifferenzierteKursart = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class GELeistungsdifferenzierteKursart extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static E = new GELeistungsdifferenzierteKursart("E", 0, "E");
    static G = new GELeistungsdifferenzierteKursart("G", 1, "G");
    static Sonstige = new GELeistungsdifferenzierteKursart("Sonstige", 2, "");
    kuerzel;
    /**
     * Erzeugt eine neue leistungsdifferenzierte Kursart.
     *
     * @param kuerzel   das Kürzel für die leistungsdifferenzierte Kursart
     */
    constructor(name, ordinal, kuerzel) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        GELeistungsdifferenzierteKursart.all_values_by_ordinal.push(this);
        GELeistungsdifferenzierteKursart.all_values_by_name.set(name, this);
        this.kuerzel = kuerzel;
    }
    /**
     * Wandelt den übergebenen String, in einen Objekt dieser Aufzählung um.
     * Dabei wird "E" als E-Kurs und "G" als G-Kurs interpretiert. Alles andere
     * wird als sonstiger Kurs interpretiert.
     *
     * @param kuerzel   die Zeichenkette, die als Kursart interpretiert werden soll
     *
     * @return das resultierende Objekt dieser Aufzählung
     */
    static from(kuerzel) {
        switch (kuerzel) {
            case "E":
                return GELeistungsdifferenzierteKursart.E;
            case "G":
                return GELeistungsdifferenzierteKursart.G;
        }
        return GELeistungsdifferenzierteKursart.Sonstige;
    }
    /**
     * Prüft, ob die leistungsdifferenzierte Kursart das übergeben Kürzel hat
     *
     * @param kuerzel   das zu prüfende Kürzel
     *
     * @return true, falls sie das Kürzel hat und ansonsten false
     */
    hat(kuerzel) {
        return JavaObject_1.JavaObject.equalsTranspiler(this.kuerzel, (GELeistungsdifferenzierteKursart.from(kuerzel).kuerzel));
    }
    /**
     * Wandelt dieses Objekt in das zugehörige Kürzel um.
     *
     * @return die Zeichenkette die zu dieser Kursart gehört
     */
    toString() {
        return this.kuerzel;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof GELeistungsdifferenzierteKursart))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.ge.GELeistungsdifferenzierteKursart'].includes(name);
    }
}
exports.GELeistungsdifferenzierteKursart = GELeistungsdifferenzierteKursart;
function cast_de_nrw_schule_svws_core_types_ge_GELeistungsdifferenzierteKursart(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_ge_GELeistungsdifferenzierteKursart = cast_de_nrw_schule_svws_core_types_ge_GELeistungsdifferenzierteKursart;
//# sourceMappingURL=GELeistungsdifferenzierteKursart.js.map