import { JavaObject } from '../../../java/lang/JavaObject';
export declare class AbiturBelegungsart extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly NICHT_BELEGT: AbiturBelegungsart;
    static readonly MUENDLICH: AbiturBelegungsart;
    static readonly SCHRIFTLICH: AbiturBelegungsart;
    kuerzel: String;
    beschreibung: String;
    /**
     * Erzeugt ein neues Abitur-Belegungsart-Objekt
     *
     * @param kuerzel        das der Kurs-Belegungsart
     * @param beschreibung   die textuelle Beschreibung der Kurs-Belegungsart
     */
    private constructor();
    /**
     * Gibt die Kurs-Belegungsart anhand des übergebenen Kürzels zurück.
     *
     * @param kuerzel    das Kürzel der Kurs-Belegungsart
     *
     * @return die Kurs-Belegungsart oder null, falls das kuerzel fehlerhaft ist
     */
    static fromKuerzel(kuerzel: String | null): AbiturBelegungsart | null;
    toString(): String;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: AbiturBelegungsart): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<AbiturBelegungsart>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): AbiturBelegungsart | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_gost_AbiturBelegungsart(obj: unknown): AbiturBelegungsart;
