"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_gost_AbiturBelegungsart = exports.AbiturBelegungsart = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class AbiturBelegungsart extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static NICHT_BELEGT = new AbiturBelegungsart("NICHT_BELEGT", 0, "-", "nicht belegt");
    static MUENDLICH = new AbiturBelegungsart("MUENDLICH", 1, "M", "mündlich");
    static SCHRIFTLICH = new AbiturBelegungsart("SCHRIFTLICH", 2, "S", "schriftlich");
    kuerzel;
    beschreibung;
    /**
     * Erzeugt ein neues Abitur-Belegungsart-Objekt
     *
     * @param kuerzel        das der Kurs-Belegungsart
     * @param beschreibung   die textuelle Beschreibung der Kurs-Belegungsart
     */
    constructor(name, ordinal, kuerzel, beschreibung) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        AbiturBelegungsart.all_values_by_ordinal.push(this);
        AbiturBelegungsart.all_values_by_name.set(name, this);
        this.kuerzel = kuerzel;
        this.beschreibung = beschreibung;
    }
    /**
     * Gibt die Kurs-Belegungsart anhand des übergebenen Kürzels zurück.
     *
     * @param kuerzel    das Kürzel der Kurs-Belegungsart
     *
     * @return die Kurs-Belegungsart oder null, falls das kuerzel fehlerhaft ist
     */
    static fromKuerzel(kuerzel) {
        if (kuerzel === null)
            return AbiturBelegungsart.NICHT_BELEGT;
        switch (kuerzel) {
            case "-":
                return AbiturBelegungsart.NICHT_BELEGT;
            case "M":
                return AbiturBelegungsart.MUENDLICH;
            case "S":
                return AbiturBelegungsart.SCHRIFTLICH;
        }
        return null;
    }
    toString() {
        return this.kuerzel;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof AbiturBelegungsart))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.gost.AbiturBelegungsart'].includes(name);
    }
}
exports.AbiturBelegungsart = AbiturBelegungsart;
function cast_de_nrw_schule_svws_core_types_gost_AbiturBelegungsart(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_gost_AbiturBelegungsart = cast_de_nrw_schule_svws_core_types_gost_AbiturBelegungsart;
//# sourceMappingURL=AbiturBelegungsart.js.map