"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_gost_GostAbiturFach = exports.GostAbiturFach = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class GostAbiturFach extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static LK1 = new GostAbiturFach("LK1", 0, 1, "LK1", "1. Leistungskurs");
    static LK2 = new GostAbiturFach("LK2", 1, 2, "LK2", "2. Leistungskurs");
    static AB3 = new GostAbiturFach("AB3", 2, 3, "AB3", "3. Abiturfach (GK, schriftlich)");
    static AB4 = new GostAbiturFach("AB4", 3, 4, "AB4", "4. Abiturfach (GK, mündlich)");
    id;
    kuerzel;
    beschreibung;
    /**
     * Erstellt eine Abiturfachart für diese Aufzählung der Abiturfacharten.
     *
     * @param id             die ID bzw. Nummer der Abiturfachart
     * @param kuerzel        das Kürzel der Abiturfachart, welches auch in speziellen Kursarten genutzt wird
     * @param beschreibung   die textuelle Beschreibung der Abiturfachart
     */
    constructor(name, ordinal, id, kuerzel, beschreibung) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        GostAbiturFach.all_values_by_ordinal.push(this);
        GostAbiturFach.all_values_by_name.set(name, this);
        this.id = id;
        this.kuerzel = kuerzel;
        this.beschreibung = beschreibung;
    }
    /**
     *
     * Gibt die Abiturfachart anhand der ID zurück.
     *
     * @param id    die ID der Abiturfachart
     *
     * @return die Abiturfachart oder null falls die ID ungültig ist
     *
     */
    static fromID(id) {
        if (id === null)
            return null;
        switch (id) {
            case 1:
                return GostAbiturFach.LK1;
            case 2:
                return GostAbiturFach.LK2;
            case 3:
                return GostAbiturFach.AB3;
            case 4:
                return GostAbiturFach.AB4;
        }
        return null;
    }
    /**
     *
     * Gibt die Abiturfachart anhand der ID (als String) zurück.
     *
     * @param strID    die ID der Abiturfachart (als String)
     *
     * @return die Abiturfachart oder null, falls die ID ungültig ist
     *
     */
    static fromIDString(strID) {
        if (strID === null)
            return null;
        switch (strID) {
            case "1":
                return GostAbiturFach.LK1;
            case "2":
                return GostAbiturFach.LK2;
            case "3":
                return GostAbiturFach.AB3;
            case "4":
                return GostAbiturFach.AB4;
        }
        return null;
    }
    /**
     *
     * Gibt die Abiturfachart anhand des Kürzels zurück.
     *
     * @param kuerzel    das Kürzel der Abiturfachart
     *
     * @return die Abiturfachart oder null, falls das Kürzel ungültig ist
     *
     */
    static fromKuerzel(kuerzel) {
        switch (kuerzel) {
            case "LK1":
                return GostAbiturFach.LK1;
            case "LK2":
                return GostAbiturFach.LK2;
            case "AB3":
                return GostAbiturFach.AB3;
            case "AB4":
                return GostAbiturFach.AB4;
        }
        return null;
    }
    toString() {
        return this.kuerzel;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof GostAbiturFach))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.gost.GostAbiturFach'].includes(name);
    }
}
exports.GostAbiturFach = GostAbiturFach;
function cast_de_nrw_schule_svws_core_types_gost_GostAbiturFach(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_gost_GostAbiturFach = cast_de_nrw_schule_svws_core_types_gost_GostAbiturFach;
//# sourceMappingURL=GostAbiturFach.js.map