import { JavaObject } from '../../../java/lang/JavaObject';
export declare class GostBesondereLernleistung extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly KEINE: GostBesondereLernleistung;
    static readonly PROJEKTKURS: GostBesondereLernleistung;
    static readonly EXTERNE: GostBesondereLernleistung;
    readonly kuerzel: String;
    readonly beschreibung: String;
    /**
     * Erzeugt ein neues Objekt für die Aufzählung der Arten von Besonderen
     * Lernleistungen.
     *
     * @param kuerzel        das Kürzel für die Art der Besonderen Lernleistung
     * @param beschreibung   die textuelle Beschreibung der Art der Besonderen Lernleistung
     */
    private constructor();
    /**
     *
     * Gibt die Art der Besonderen Lernleistung anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Art der Besonderen Lernleistung
     *
     * @return die Art der Besonderen Lernleistung
     */
    static fromKuerzel(kuerzel: String | null): GostBesondereLernleistung;
    toString(): String;
    /**
     * Prüft, ob diese Art der Besonderen Lernleistung mit der Art der c
     * Lernleistung des übergebenen Kürzels übereinstimmt.
     *
     * @param kuerzel   das zu prüfende Kürzel der anderen Art der
     *                  besonderen Lernleistung
     *
     * @return true, falls die Arten übereinstimmen und ansonsten false
     */
    is(kuerzel: String | null): boolean;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: GostBesondereLernleistung): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<GostBesondereLernleistung>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): GostBesondereLernleistung | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_gost_GostBesondereLernleistung(obj: unknown): GostBesondereLernleistung;
