"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_gost_GostBesondereLernleistung = exports.GostBesondereLernleistung = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class GostBesondereLernleistung extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static KEINE = new GostBesondereLernleistung("KEINE", 0, "K", "Keine");
    static PROJEKTKURS = new GostBesondereLernleistung("PROJEKTKURS", 1, "P", "Projektkurs ist besondere Lernleistung");
    static EXTERNE = new GostBesondereLernleistung("EXTERNE", 2, "E", "externe besondere Lernleistung");
    kuerzel;
    beschreibung;
    /**
     * Erzeugt ein neues Objekt für die Aufzählung der Arten von Besonderen
     * Lernleistungen.
     *
     * @param kuerzel        das Kürzel für die Art der Besonderen Lernleistung
     * @param beschreibung   die textuelle Beschreibung der Art der Besonderen Lernleistung
     */
    constructor(name, ordinal, kuerzel, beschreibung) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        GostBesondereLernleistung.all_values_by_ordinal.push(this);
        GostBesondereLernleistung.all_values_by_name.set(name, this);
        this.kuerzel = kuerzel;
        this.beschreibung = beschreibung;
    }
    /**
     *
     * Gibt die Art der Besonderen Lernleistung anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Art der Besonderen Lernleistung
     *
     * @return die Art der Besonderen Lernleistung
     */
    static fromKuerzel(kuerzel) {
        if (kuerzel === null)
            return GostBesondereLernleistung.KEINE;
        switch (kuerzel) {
            case "K":
                return GostBesondereLernleistung.KEINE;
            case "P":
                return GostBesondereLernleistung.PROJEKTKURS;
            case "E":
                return GostBesondereLernleistung.EXTERNE;
        }
        return GostBesondereLernleistung.KEINE;
    }
    toString() {
        return this.kuerzel;
    }
    /**
     * Prüft, ob diese Art der Besonderen Lernleistung mit der Art der c
     * Lernleistung des übergebenen Kürzels übereinstimmt.
     *
     * @param kuerzel   das zu prüfende Kürzel der anderen Art der
     *                  besonderen Lernleistung
     *
     * @return true, falls die Arten übereinstimmen und ansonsten false
     */
    is(kuerzel) {
        return JavaObject_1.JavaObject.equalsTranspiler(this.kuerzel, (kuerzel));
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof GostBesondereLernleistung))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.gost.GostBesondereLernleistung'].includes(name);
    }
}
exports.GostBesondereLernleistung = GostBesondereLernleistung;
function cast_de_nrw_schule_svws_core_types_gost_GostBesondereLernleistung(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_gost_GostBesondereLernleistung = cast_de_nrw_schule_svws_core_types_gost_GostBesondereLernleistung;
//# sourceMappingURL=GostBesondereLernleistung.js.map