"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_gost_GostFremdsprachenart = exports.GostFremdsprachenart = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
class GostFremdsprachenart extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static FORTGEFUEHRT = new GostFremdsprachenart("FORTGEFUEHRT", 0, 0, "fortgeführt");
    static NEU = new GostFremdsprachenart("NEU", 1, 1, "neu einsetzend");
    static BELIEBIG = new GostFremdsprachenart("BELIEBIG", 2, 2, "beliebig");
    id;
    bezeichnung;
    /**
     * Erzeugt eine neue Fremdsprachenart für die Aufzählung.
     *
     * @param id            die eindeutige ID für die Fremdsprachenart
     * @param bezeichnung   die Bezeichnung der Fremdsprachenart als Text
     */
    constructor(name, ordinal, id, bezeichnung) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        GostFremdsprachenart.all_values_by_ordinal.push(this);
        GostFremdsprachenart.all_values_by_name.set(name, this);
        this.id = id;
        this.bezeichnung = bezeichnung;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof GostFremdsprachenart))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.gost.GostFremdsprachenart'].includes(name);
    }
}
exports.GostFremdsprachenart = GostFremdsprachenart;
function cast_de_nrw_schule_svws_core_types_gost_GostFremdsprachenart(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_gost_GostFremdsprachenart = cast_de_nrw_schule_svws_core_types_gost_GostFremdsprachenart;
//# sourceMappingURL=GostFremdsprachenart.js.map