import { JavaObject } from '../../../java/lang/JavaObject';
import { Collection } from '../../../java/util/Collection';
export declare class GostKursart extends JavaObject {
    private static readonly map;
    static readonly LK: GostKursart;
    static readonly GK: GostKursart;
    static readonly ZK: GostKursart;
    static readonly PJK: GostKursart;
    static readonly VTF: GostKursart;
    readonly id: number;
    readonly kuerzel: String;
    readonly beschreibung: String;
    /**
     * Erzeugt eine neue Kursart für die Aufzählung.
     *
     * @param id             die eindeutige ID der Kursart der Gymnasialen Oberstufe
     * @param kuerzel        das Kürzel der Kursart der Gymnasialen Oberstufe
     * @param beschreibung   die textuelle Beschreibung der allgemeinen Kursart der Gymnasialen Oberstufe
     */
    private constructor();
    /**
     * Prüft die Anzahl der Wochenstunden zu der Kursart.
     *
     * @param anzahl   Anzahl der Wochenstunden
     *
     * @return         Anzahl der Wochenstunden der Kursart korrekt, true oder false
     */
    pruefeWochenstunden(anzahl: number): boolean;
    /**
     * Gibt alle Kursarten der gymnasialen Oberstufe zurück.
     *
     * @return eine {@link Collection} mit den Kursarten.
     */
    static values(): Collection<GostKursart>;
    /**
     * Gibt die Kursart aus dem Kürzel der Kursart zurück.
     *
     * @param kuerzel    das Kürzel der Kursart
     *
     * @return die Kursart oder null, falls das Kürzel ungültig ist
     */
    static fromKuerzel(kuerzel: String | null): GostKursart | null;
    toString(): String;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_gost_GostKursart(obj: unknown): GostKursart;
