import { JavaObject } from '../../../java/lang/JavaObject';
import { LehrerKatalogBeschaeftigungsartEintrag } from '../../../core/data/lehrer/LehrerKatalogBeschaeftigungsartEintrag';
export declare class LehrerBeschaeftigungsart extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly V: LehrerBeschaeftigungsart;
    static readonly T: LehrerBeschaeftigungsart;
    static readonly AT: LehrerBeschaeftigungsart;
    static readonly TA: LehrerBeschaeftigungsart;
    static readonly VA: LehrerBeschaeftigungsart;
    static readonly TS: LehrerBeschaeftigungsart;
    static readonly SB: LehrerBeschaeftigungsart;
    static readonly GB: LehrerBeschaeftigungsart;
    static readonly ST: LehrerBeschaeftigungsart;
    static readonly NA: LehrerBeschaeftigungsart;
    static readonly G: LehrerBeschaeftigungsart;
    static readonly X: LehrerBeschaeftigungsart;
    static readonly WT: LehrerBeschaeftigungsart;
    static readonly WV: LehrerBeschaeftigungsart;
    static VERSION: number;
    readonly daten: LehrerKatalogBeschaeftigungsartEintrag;
    readonly historie: Array<LehrerKatalogBeschaeftigungsartEintrag>;
    private static readonly _artenByID;
    private static readonly _artenByKuerzel;
    /**
     * Erzeugt eine neue Beschäftigungsart in der Aufzählung.
     *
     * @param historie   die Historie der Beschäftigungsart, welches ein Array von {@link LehrerKatalogBeschaeftigungsartEintrag} ist
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     */
    private static getMapArtenByID;
    /**
     * Gibt eine Map von den Kürzeln der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     */
    private static getMapArtenByKuerzel;
    /**
     * Gibt die Beschäftigungsart anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Beschäftigungsart
     *
     * @return die Beschäftigungsart oder null, falls die ID ungültig ist
     */
    static getByID(id: number): LehrerBeschaeftigungsart | null;
    /**
     * Gibt die Beschäftigungsart anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Beschäftigungsart
     *
     * @return die Beschäftigungsart oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel: String | null): LehrerBeschaeftigungsart | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: LehrerBeschaeftigungsart): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<LehrerBeschaeftigungsart>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): LehrerBeschaeftigungsart | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_statkue_LehrerBeschaeftigungsart(obj: unknown): LehrerBeschaeftigungsart;
