"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerBeschaeftigungsart = exports.LehrerBeschaeftigungsart = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const HashMap_1 = require("../../../java/util/HashMap");
const LehrerKatalogBeschaeftigungsartEintrag_1 = require("../../../core/data/lehrer/LehrerKatalogBeschaeftigungsartEintrag");
class LehrerBeschaeftigungsart extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static V = new LehrerBeschaeftigungsart("V", 0, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(1, "V", "Vollzeit", null, null)]);
    static T = new LehrerBeschaeftigungsart("T", 1, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(2, "T", "Teilzeit", null, null)]);
    static AT = new LehrerBeschaeftigungsart("AT", 2, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(3, "AT", "Altersteilzeit (Beschäftigungsphase)", null, null)]);
    static TA = new LehrerBeschaeftigungsart("TA", 3, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(4, "TA", "Altersteilzeit, vorm. teilzeitbeschäftigt (Verzichtsphase Altersermäßigung)", null, null)]);
    static VA = new LehrerBeschaeftigungsart("VA", 4, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(5, "VA", "Altersteilzeit, vorm. vollzeitbeschäftigt (Verzichtsphase Altersermäßigung)", null, null)]);
    static TS = new LehrerBeschaeftigungsart("TS", 5, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(6, "TS", "Sabbatjahr", null, null)]);
    static SB = new LehrerBeschaeftigungsart("SB", 6, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(8, "SB", "Nebenberufliche Beschäftigtigung", null, null)]);
    static GB = new LehrerBeschaeftigungsart("GB", 7, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(9, "GB", "Geringfügige Beschäftigtigung", null, null)]);
    static ST = new LehrerBeschaeftigungsart("ST", 8, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(11, "ST", "Studierende", null, null)]);
    static NA = new LehrerBeschaeftigungsart("NA", 9, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(12, "NA", "Beamter, nebenamtlich (nicht hauptamtlich im Schuldienst)", null, null)]);
    static G = new LehrerBeschaeftigungsart("G", 10, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(13, "G", "Gestellungsvertrag", null, null)]);
    static X = new LehrerBeschaeftigungsart("X", 11, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(15, "X", "Unentgeltlich Beschäftigte", null, null)]);
    static WT = new LehrerBeschaeftigungsart("WT", 12, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(16, "WT", "Beamte auf Widerruf (LAA) in Teilzeit", null, null)]);
    static WV = new LehrerBeschaeftigungsart("WV", 13, [new LehrerKatalogBeschaeftigungsartEintrag_1.LehrerKatalogBeschaeftigungsartEintrag(17, "WV", "Beamte auf Widerruf (LAA) in Vollzeit", null, null)]);
    static VERSION = 1;
    daten;
    historie;
    static _artenByID = new HashMap_1.HashMap();
    static _artenByKuerzel = new HashMap_1.HashMap();
    /**
     * Erzeugt eine neue Beschäftigungsart in der Aufzählung.
     *
     * @param historie   die Historie der Beschäftigungsart, welches ein Array von {@link LehrerKatalogBeschaeftigungsartEintrag} ist
     */
    constructor(name, ordinal, historie) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        LehrerBeschaeftigungsart.all_values_by_ordinal.push(this);
        LehrerBeschaeftigungsart.all_values_by_name.set(name, this);
        this.historie = historie;
        this.daten = historie[historie.length - 1];
    }
    /**
     * Gibt eine Map von den IDs der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     */
    static getMapArtenByID() {
        if (LehrerBeschaeftigungsart._artenByID.size() === 0)
            for (let l of LehrerBeschaeftigungsart.values())
                LehrerBeschaeftigungsart._artenByID.put(l.daten.id, l);
        return LehrerBeschaeftigungsart._artenByID;
    }
    /**
     * Gibt eine Map von den Kürzeln der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Beschäftigungsarten auf die zugehörigen Beschäftigungsarten
     */
    static getMapArtenByKuerzel() {
        if (LehrerBeschaeftigungsart._artenByKuerzel.size() === 0)
            for (let l of LehrerBeschaeftigungsart.values())
                LehrerBeschaeftigungsart._artenByKuerzel.put(l.daten.kuerzel, l);
        return LehrerBeschaeftigungsart._artenByKuerzel;
    }
    /**
     * Gibt die Beschäftigungsart anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Beschäftigungsart
     *
     * @return die Beschäftigungsart oder null, falls die ID ungültig ist
     */
    static getByID(id) {
        return LehrerBeschaeftigungsart.getMapArtenByID().get(id);
    }
    /**
     * Gibt die Beschäftigungsart anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Beschäftigungsart
     *
     * @return die Beschäftigungsart oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel) {
        return LehrerBeschaeftigungsart.getMapArtenByKuerzel().get(kuerzel);
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof LehrerBeschaeftigungsart))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.statkue.LehrerBeschaeftigungsart'].includes(name);
    }
}
exports.LehrerBeschaeftigungsart = LehrerBeschaeftigungsart;
function cast_de_nrw_schule_svws_core_types_statkue_LehrerBeschaeftigungsart(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerBeschaeftigungsart = cast_de_nrw_schule_svws_core_types_statkue_LehrerBeschaeftigungsart;
//# sourceMappingURL=LehrerBeschaeftigungsart.js.map