"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerEinsatzstatus = exports.LehrerEinsatzstatus = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const HashMap_1 = require("../../../java/util/HashMap");
const LehrerKatalogEinsatzstatusEintrag_1 = require("../../../core/data/lehrer/LehrerKatalogEinsatzstatusEintrag");
class LehrerEinsatzstatus extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static A = new LehrerEinsatzstatus("A", 0, [new LehrerKatalogEinsatzstatusEintrag_1.LehrerKatalogEinsatzstatusEintrag(1, "A", "Stammschule, ganz oder teilweise auch an anderen Schulen tätig", null, null)]);
    static B = new LehrerEinsatzstatus("B", 1, [new LehrerKatalogEinsatzstatusEintrag_1.LehrerKatalogEinsatzstatusEintrag(2, "B", "nicht Stammschule, aber auch hier tätig", null, null)]);
    static DEFAULT = new LehrerEinsatzstatus("DEFAULT", 2, [new LehrerKatalogEinsatzstatusEintrag_1.LehrerKatalogEinsatzstatusEintrag(3, "*", "Stammschule, nur hier tätig", null, null)]);
    static VERSION = 1;
    daten;
    historie;
    static _statusByID = new HashMap_1.HashMap();
    static _statusByKuerzel = new HashMap_1.HashMap();
    /**
     * Erzeugt einen neuen Einsatzstatus in der Aufzählung.
     *
     * @param historie   die Historie des Einsatzstatus, welches ein Array von {@link LehrerKatalogEinsatzstatusEintrag} ist
     */
    constructor(name, ordinal, historie) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        LehrerEinsatzstatus.all_values_by_ordinal.push(this);
        LehrerEinsatzstatus.all_values_by_name.set(name, this);
        this.historie = historie;
        this.daten = historie[historie.length - 1];
    }
    /**
     * Gibt eine Map von der ID des Einsatzstatus auf den zugehörigen Einsatzstatus
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von der ID des Einsatzstatus auf den zugehörigen Einsatzstatus
     */
    static getMapStatusByID() {
        if (LehrerEinsatzstatus._statusByID.size() === 0)
            for (let g of LehrerEinsatzstatus.values())
                LehrerEinsatzstatus._statusByID.put(g.daten.id, g);
        return LehrerEinsatzstatus._statusByID;
    }
    /**
     * Gibt eine Map von de Kürzel des Einsatzstatus auf den zugehörigen Einsatzstatus
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von de Kürzel des Einsatzstatus auf den zugehörigen Einsatzstatus
     */
    static getMapStatusByKuerzel() {
        if (LehrerEinsatzstatus._statusByKuerzel.size() === 0)
            for (let g of LehrerEinsatzstatus.values())
                LehrerEinsatzstatus._statusByKuerzel.put(g.daten.kuerzel, g);
        return LehrerEinsatzstatus._statusByKuerzel;
    }
    /**
     * Gibt den Einsatzstatus anhand der angegebenen ID zurück.
     *
     * @param id   die ID des Einsatzstatus
     *
     * @return der Einsatzstatus oder null, falls die ID ungültig ist
     */
    static getByID(id) {
        return LehrerEinsatzstatus.getMapStatusByID().get(id);
    }
    /**
     * Gibt den Einsatzstatus anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel des Einsatzstatus
     *
     * @return der Einsatzstatus oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel) {
        return LehrerEinsatzstatus.getMapStatusByKuerzel().get(kuerzel);
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof LehrerEinsatzstatus))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.statkue.LehrerEinsatzstatus'].includes(name);
    }
}
exports.LehrerEinsatzstatus = LehrerEinsatzstatus;
function cast_de_nrw_schule_svws_core_types_statkue_LehrerEinsatzstatus(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerEinsatzstatus = cast_de_nrw_schule_svws_core_types_statkue_LehrerEinsatzstatus;
//# sourceMappingURL=LehrerEinsatzstatus.js.map