import { JavaObject } from '../../../java/lang/JavaObject';
import { LehrerKatalogLehramtEintrag } from '../../../core/data/lehrer/LehrerKatalogLehramtEintrag';
export declare class LehrerLehramt extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly ID_00: LehrerLehramt;
    static readonly ID_01: LehrerLehramt;
    static readonly ID_02: LehrerLehramt;
    static readonly ID_03: LehrerLehramt;
    static readonly ID_09: LehrerLehramt;
    static readonly ID_10: LehrerLehramt;
    static readonly ID_11: LehrerLehramt;
    static readonly ID_12: LehrerLehramt;
    static readonly ID_14: LehrerLehramt;
    static readonly ID_15: LehrerLehramt;
    static readonly ID_16: LehrerLehramt;
    static readonly ID_19: LehrerLehramt;
    static readonly ID_20: LehrerLehramt;
    static readonly ID_21: LehrerLehramt;
    static readonly ID_24: LehrerLehramt;
    static readonly ID_25: LehrerLehramt;
    static readonly ID_27: LehrerLehramt;
    static readonly ID_29: LehrerLehramt;
    static readonly ID_30: LehrerLehramt;
    static readonly ID_31: LehrerLehramt;
    static readonly ID_32: LehrerLehramt;
    static readonly ID_35: LehrerLehramt;
    static readonly ID_40: LehrerLehramt;
    static readonly ID_50: LehrerLehramt;
    static readonly ID_51: LehrerLehramt;
    static readonly ID_52: LehrerLehramt;
    static readonly ID_53: LehrerLehramt;
    static readonly ID_54: LehrerLehramt;
    static readonly ID_55: LehrerLehramt;
    static readonly ID_56: LehrerLehramt;
    static readonly ID_57: LehrerLehramt;
    static readonly ID_58: LehrerLehramt;
    static readonly ID_59: LehrerLehramt;
    static readonly ID_60: LehrerLehramt;
    static readonly ID_61: LehrerLehramt;
    static readonly ID_62: LehrerLehramt;
    static readonly ID_96: LehrerLehramt;
    static readonly ID_97: LehrerLehramt;
    static readonly ID_98: LehrerLehramt;
    static readonly ID_99: LehrerLehramt;
    static readonly ID_70: LehrerLehramt;
    static readonly ID_04: LehrerLehramt;
    static readonly ID_17: LehrerLehramt;
    static readonly ID_08: LehrerLehramt;
    static readonly ID_18: LehrerLehramt;
    static readonly ID_49: LehrerLehramt;
    static VERSION: number;
    readonly daten: LehrerKatalogLehramtEintrag;
    readonly historie: Array<LehrerKatalogLehramtEintrag>;
    private static readonly _aemterByID;
    private static readonly _aemterByKuerzel;
    /**
     * Erzeugt ein neues Lehramt in der Aufzählung.
     *
     * @param historie   die Historie des Lehramtes, welches ein Array von {@link LehrerKatalogLehramtEintrag} ist
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Lehrämter auf die zugehörigen Lehrämter
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Lehrämter auf die zugehörigen Lehrämter
     */
    private static getMapLehraemterByID;
    /**
     * Gibt eine Map von den Kürzeln der Lehrämter auf die zugehörigen Lehrämter
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Lehrämter auf die zugehörigen Lehrämter
     */
    private static getMapLehraemterByKuerzel;
    /**
     * Gibt das Lehramt anhand der angegebenen ID zurück.
     *
     * @param id   die ID des Lehramts
     *
     * @return das Lehramt oder null, falls die ID ungültig ist
     */
    static getByID(id: number): LehrerLehramt | null;
    /**
     * Gibt das Lehramt anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel des Lehramts
     *
     * @return das Lehramt oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel: String | null): LehrerLehramt | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: LehrerLehramt): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<LehrerLehramt>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): LehrerLehramt | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_statkue_LehrerLehramt(obj: unknown): LehrerLehramt;
