import { JavaObject } from '../../../java/lang/JavaObject';
import { LehrerKatalogLehramtAnerkennungEintrag } from '../../../core/data/lehrer/LehrerKatalogLehramtAnerkennungEintrag';
export declare class LehrerLehramtAnerkennung extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly ST: LehrerLehramtAnerkennung;
    static readonly AL: LehrerLehramtAnerkennung;
    static readonly AP: LehrerLehramtAnerkennung;
    static readonly BT: LehrerLehramtAnerkennung;
    static readonly OH: LehrerLehramtAnerkennung;
    static VERSION: number;
    readonly daten: LehrerKatalogLehramtAnerkennungEintrag;
    readonly historie: Array<LehrerKatalogLehramtAnerkennungEintrag>;
    private static readonly _anerkennungenByID;
    private static readonly _anerkennungenByKuerzel;
    /**
     * Erzeugt eine neue Lehramtsanerkennung in der Aufzählung.
     *
     * @param historie   die Historie der Lehramtsanerkennung, welches ein Array von {@link LehrerKatalogLehramtAnerkennungEintrag} ist
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     */
    private static getMapAnerkennungenByID;
    /**
     * Gibt eine Map von den Kürzeln der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     */
    private static getMapAnerkennungenByKuerzel;
    /**
     * Gibt die Lehramtsanerkennung anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Lehramtsanerkennung
     *
     * @return die Lehramtsanerkennung oder null, falls die ID ungültig ist.
     */
    static getByID(id: number): LehrerLehramtAnerkennung | null;
    /**
     * Gibt die Lehramtsanerkennung anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Lehramtsanerkennung
     *
     * @return die Lehramtsanerkennung oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel: String | null): LehrerLehramtAnerkennung | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: LehrerLehramtAnerkennung): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<LehrerLehramtAnerkennung>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): LehrerLehramtAnerkennung | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_statkue_LehrerLehramtAnerkennung(obj: unknown): LehrerLehramtAnerkennung;
