"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerLehramtAnerkennung = exports.LehrerLehramtAnerkennung = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const LehrerKatalogLehramtAnerkennungEintrag_1 = require("../../../core/data/lehrer/LehrerKatalogLehramtAnerkennungEintrag");
const HashMap_1 = require("../../../java/util/HashMap");
class LehrerLehramtAnerkennung extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static ST = new LehrerLehramtAnerkennung("ST", 0, [new LehrerKatalogLehramtAnerkennungEintrag_1.LehrerKatalogLehramtAnerkennungEintrag(1, "ST", "Zweite Staatsprüfung für ein Lehramt", null, null)]);
    static AL = new LehrerLehramtAnerkennung("AL", 1, [new LehrerKatalogLehramtAnerkennungEintrag_1.LehrerKatalogLehramtAnerkennungEintrag(2, "AL", "Anerkennung Lehramt", null, null)]);
    static AP = new LehrerLehramtAnerkennung("AP", 2, [new LehrerKatalogLehramtAnerkennungEintrag_1.LehrerKatalogLehramtAnerkennungEintrag(3, "AP", "Anerkennung geeignete Prüfung", null, null)]);
    static BT = new LehrerLehramtAnerkennung("BT", 3, [new LehrerKatalogLehramtAnerkennungEintrag_1.LehrerKatalogLehramtAnerkennungEintrag(4, "BT", "Förderliche Berufstätigkeit", null, null)]);
    static OH = new LehrerLehramtAnerkennung("OH", 4, [new LehrerKatalogLehramtAnerkennungEintrag_1.LehrerKatalogLehramtAnerkennungEintrag(5, "OH", "ohne", null, null)]);
    static VERSION = 1;
    daten;
    historie;
    static _anerkennungenByID = new HashMap_1.HashMap();
    static _anerkennungenByKuerzel = new HashMap_1.HashMap();
    /**
     * Erzeugt eine neue Lehramtsanerkennung in der Aufzählung.
     *
     * @param historie   die Historie der Lehramtsanerkennung, welches ein Array von {@link LehrerKatalogLehramtAnerkennungEintrag} ist
     */
    constructor(name, ordinal, historie) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        LehrerLehramtAnerkennung.all_values_by_ordinal.push(this);
        LehrerLehramtAnerkennung.all_values_by_name.set(name, this);
        this.historie = historie;
        this.daten = historie[historie.length - 1];
    }
    /**
     * Gibt eine Map von den IDs der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     */
    static getMapAnerkennungenByID() {
        if (LehrerLehramtAnerkennung._anerkennungenByID.size() === 0)
            for (let l of LehrerLehramtAnerkennung.values())
                LehrerLehramtAnerkennung._anerkennungenByID.put(l.daten.id, l);
        return LehrerLehramtAnerkennung._anerkennungenByID;
    }
    /**
     * Gibt eine Map von den Kürzeln der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Lehramtssanerkennungen auf die zugehörigen Lehramtssanerkennungen
     */
    static getMapAnerkennungenByKuerzel() {
        if (LehrerLehramtAnerkennung._anerkennungenByKuerzel.size() === 0)
            for (let l of LehrerLehramtAnerkennung.values())
                LehrerLehramtAnerkennung._anerkennungenByKuerzel.put(l.daten.kuerzel, l);
        return LehrerLehramtAnerkennung._anerkennungenByKuerzel;
    }
    /**
     * Gibt die Lehramtsanerkennung anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Lehramtsanerkennung
     *
     * @return die Lehramtsanerkennung oder null, falls die ID ungültig ist.
     */
    static getByID(id) {
        return LehrerLehramtAnerkennung.getMapAnerkennungenByID().get(id);
    }
    /**
     * Gibt die Lehramtsanerkennung anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Lehramtsanerkennung
     *
     * @return die Lehramtsanerkennung oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel) {
        return LehrerLehramtAnerkennung.getMapAnerkennungenByKuerzel().get(kuerzel);
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof LehrerLehramtAnerkennung))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.statkue.LehrerLehramtAnerkennung'].includes(name);
    }
}
exports.LehrerLehramtAnerkennung = LehrerLehramtAnerkennung;
function cast_de_nrw_schule_svws_core_types_statkue_LehrerLehramtAnerkennung(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerLehramtAnerkennung = cast_de_nrw_schule_svws_core_types_statkue_LehrerLehramtAnerkennung;
//# sourceMappingURL=LehrerLehramtAnerkennung.js.map