import { JavaObject } from '../../../java/lang/JavaObject';
import { LehrerKatalogLehrbefaehigungAnerkennungEintrag } from '../../../core/data/lehrer/LehrerKatalogLehrbefaehigungAnerkennungEintrag';
export declare class LehrerLehrbefaehigungAnerkennung extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly ID_1: LehrerLehrbefaehigungAnerkennung;
    static readonly ID_2: LehrerLehrbefaehigungAnerkennung;
    static readonly ID_3: LehrerLehrbefaehigungAnerkennung;
    static readonly ID_9: LehrerLehrbefaehigungAnerkennung;
    static VERSION: number;
    readonly daten: LehrerKatalogLehrbefaehigungAnerkennungEintrag;
    readonly historie: Array<LehrerKatalogLehrbefaehigungAnerkennungEintrag>;
    private static readonly _anerkennungenByID;
    private static readonly _anerkennungenByKuerzel;
    /**
     * Erzeugt einen neuen Anerkennungsgrund für Lehrbefähigungen in der Aufzählung.
     *
     * @param historie   die Historie der Lehrbefähigung, welches ein Array von {@link LehrerKatalogLehrbefaehigungAnerkennungEintrag} ist
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     */
    private static getMapAnerkennungenByID;
    /**
     * Gibt eine Map von den Kürzeln der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     */
    private static getMapAnerkennungenByKuerzel;
    /**
     * Gibt den Anerkennungsgrund für Lehrbefähigungen anhand der angegebenen ID zurück.
     *
     * @param id   die ID des Anerkennungsgrunded für Lehrbefähigungen
     *
     * @return der Anerkennungsgrund für Lehrbefähigungen oder null, falls die ID ungültig ist
     */
    static getByID(id: number): LehrerLehrbefaehigungAnerkennung | null;
    /**
     * Gibt den Anerkennungsgrund für Lehrbefähigungen anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel des Anerkennungsgrunded für Lehrbefähigungen
     *
     * @return der Anerkennungsgrund für Lehrbefähigungen oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel: String | null): LehrerLehrbefaehigungAnerkennung | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: LehrerLehrbefaehigungAnerkennung): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<LehrerLehrbefaehigungAnerkennung>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): LehrerLehrbefaehigungAnerkennung | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_statkue_LehrerLehrbefaehigungAnerkennung(obj: unknown): LehrerLehrbefaehigungAnerkennung;
