"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerLehrbefaehigungAnerkennung = exports.LehrerLehrbefaehigungAnerkennung = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const LehrerKatalogLehrbefaehigungAnerkennungEintrag_1 = require("../../../core/data/lehrer/LehrerKatalogLehrbefaehigungAnerkennungEintrag");
const HashMap_1 = require("../../../java/util/HashMap");
class LehrerLehrbefaehigungAnerkennung extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static ID_1 = new LehrerLehrbefaehigungAnerkennung("ID_1", 0, [new LehrerKatalogLehrbefaehigungAnerkennungEintrag_1.LehrerKatalogLehrbefaehigungAnerkennungEintrag(1, "1", "erworben durch LABG/OVP bzw. Laufbahnverordnung", null, null)]);
    static ID_2 = new LehrerLehrbefaehigungAnerkennung("ID_2", 1, [new LehrerKatalogLehrbefaehigungAnerkennungEintrag_1.LehrerKatalogLehrbefaehigungAnerkennungEintrag(2, "2", "Unterrichtserlaubnis (z. B. Zertifikatskurs)", null, null)]);
    static ID_3 = new LehrerLehrbefaehigungAnerkennung("ID_3", 2, [new LehrerKatalogLehrbefaehigungAnerkennungEintrag_1.LehrerKatalogLehrbefaehigungAnerkennungEintrag(3, "3", "mehrjähriger Unterricht ohne Lehramtsprüfung oder Unterrichtserlaubnis", null, null)]);
    static ID_9 = new LehrerLehrbefaehigungAnerkennung("ID_9", 3, [new LehrerKatalogLehrbefaehigungAnerkennungEintrag_1.LehrerKatalogLehrbefaehigungAnerkennungEintrag(4, "9", "sonstige", null, null)]);
    static VERSION = 1;
    daten;
    historie;
    static _anerkennungenByID = new HashMap_1.HashMap();
    static _anerkennungenByKuerzel = new HashMap_1.HashMap();
    /**
     * Erzeugt einen neuen Anerkennungsgrund für Lehrbefähigungen in der Aufzählung.
     *
     * @param historie   die Historie der Lehrbefähigung, welches ein Array von {@link LehrerKatalogLehrbefaehigungAnerkennungEintrag} ist
     */
    constructor(name, ordinal, historie) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        LehrerLehrbefaehigungAnerkennung.all_values_by_ordinal.push(this);
        LehrerLehrbefaehigungAnerkennung.all_values_by_name.set(name, this);
        this.historie = historie;
        this.daten = historie[historie.length - 1];
    }
    /**
     * Gibt eine Map von den IDs der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     */
    static getMapAnerkennungenByID() {
        if (LehrerLehrbefaehigungAnerkennung._anerkennungenByID.size() === 0)
            for (let l of LehrerLehrbefaehigungAnerkennung.values())
                LehrerLehrbefaehigungAnerkennung._anerkennungenByID.put(l.daten.id, l);
        return LehrerLehrbefaehigungAnerkennung._anerkennungenByID;
    }
    /**
     * Gibt eine Map von den Kürzeln der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Lehrbefaehigungssanerkennungen auf die zugehörigen Lehrbefaehigungssanerkennungen
     */
    static getMapAnerkennungenByKuerzel() {
        if (LehrerLehrbefaehigungAnerkennung._anerkennungenByKuerzel.size() === 0)
            for (let l of LehrerLehrbefaehigungAnerkennung.values())
                LehrerLehrbefaehigungAnerkennung._anerkennungenByKuerzel.put(l.daten.kuerzel, l);
        return LehrerLehrbefaehigungAnerkennung._anerkennungenByKuerzel;
    }
    /**
     * Gibt den Anerkennungsgrund für Lehrbefähigungen anhand der angegebenen ID zurück.
     *
     * @param id   die ID des Anerkennungsgrunded für Lehrbefähigungen
     *
     * @return der Anerkennungsgrund für Lehrbefähigungen oder null, falls die ID ungültig ist
     */
    static getByID(id) {
        return LehrerLehrbefaehigungAnerkennung.getMapAnerkennungenByID().get(id);
    }
    /**
     * Gibt den Anerkennungsgrund für Lehrbefähigungen anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel des Anerkennungsgrunded für Lehrbefähigungen
     *
     * @return der Anerkennungsgrund für Lehrbefähigungen oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel) {
        return LehrerLehrbefaehigungAnerkennung.getMapAnerkennungenByKuerzel().get(kuerzel);
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof LehrerLehrbefaehigungAnerkennung))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.statkue.LehrerLehrbefaehigungAnerkennung'].includes(name);
    }
}
exports.LehrerLehrbefaehigungAnerkennung = LehrerLehrbefaehigungAnerkennung;
function cast_de_nrw_schule_svws_core_types_statkue_LehrerLehrbefaehigungAnerkennung(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerLehrbefaehigungAnerkennung = cast_de_nrw_schule_svws_core_types_statkue_LehrerLehrbefaehigungAnerkennung;
//# sourceMappingURL=LehrerLehrbefaehigungAnerkennung.js.map