import { JavaObject } from '../../../java/lang/JavaObject';
import { LehrerKatalogMinderleistungsartEintrag } from '../../../core/data/lehrer/LehrerKatalogMinderleistungsartEintrag';
export declare class LehrerMinderleistungArt extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly ID_200: LehrerMinderleistungArt;
    static readonly ID_210: LehrerMinderleistungArt;
    static readonly ID_220: LehrerMinderleistungArt;
    static readonly ID_230: LehrerMinderleistungArt;
    static readonly ID_240: LehrerMinderleistungArt;
    static readonly ID_250: LehrerMinderleistungArt;
    static readonly ID_255: LehrerMinderleistungArt;
    static readonly ID_260: LehrerMinderleistungArt;
    static readonly ID_270: LehrerMinderleistungArt;
    static readonly ID_275: LehrerMinderleistungArt;
    static readonly ID_280: LehrerMinderleistungArt;
    static readonly ID_290: LehrerMinderleistungArt;
    static readonly ID_300: LehrerMinderleistungArt;
    static readonly ID_350: LehrerMinderleistungArt;
    static readonly ID_360: LehrerMinderleistungArt;
    static readonly ID_365: LehrerMinderleistungArt;
    static readonly ID_370: LehrerMinderleistungArt;
    static readonly ID_380: LehrerMinderleistungArt;
    static VERSION: number;
    readonly daten: LehrerKatalogMinderleistungsartEintrag;
    readonly historie: Array<LehrerKatalogMinderleistungsartEintrag>;
    private static readonly _artenByID;
    private static readonly _artenByKuerzel;
    /**
     * Erzeugt eine neue Art von Minderleistung in der Aufzählung.
     *
     * @param historie   die Historie der Art von Minderleistung, welches ein Array von {@link LehrerKatalogMinderleistungsartEintrag} ist
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Minderleistungsarten auf die zugehörigen Minderleistungsarten
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Minderleistungsarten auf die zugehörigen Minderleistungsarten
     */
    private static getMapArtenByID;
    /**
     * Gibt eine Map von den Kürzeln der Minderleistungsarten auf die zugehörigen Minderleistungsarten
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Minderleistungsarten auf die zugehörigen Minderleistungsarten
     */
    private static getMapArtenByKuerzel;
    /**
     * Gibt die Art der Minderleistung anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Art der Minderleistung
     *
     * @return die Art der Minderleistung oder null, falls die ID ungültig ist
     */
    static getByID(id: number): LehrerMinderleistungArt | null;
    /**
     * Gibt die Art der Minderleistung anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Art der Minderleistung
     *
     * @return die Art der Minderleistung oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel: String | null): LehrerMinderleistungArt | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: LehrerMinderleistungArt): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<LehrerMinderleistungArt>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): LehrerMinderleistungArt | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_statkue_LehrerMinderleistungArt(obj: unknown): LehrerMinderleistungArt;
