import { JavaObject } from '../../../java/lang/JavaObject';
import { LehrerKatalogRechtsverhaeltnisEintrag } from '../../../core/data/lehrer/LehrerKatalogRechtsverhaeltnisEintrag';
export declare class LehrerRechtsverhaeltnis extends JavaObject {
    /** the name of the enumeration value */
    private readonly __name;
    /** the ordinal value for the enumeration value */
    private readonly __ordinal;
    /** an array containing all values of this enumeration */
    private static readonly all_values_by_ordinal;
    /** an array containing all values of this enumeration indexed by their name*/
    private static readonly all_values_by_name;
    static readonly L: LehrerRechtsverhaeltnis;
    static readonly P: LehrerRechtsverhaeltnis;
    static readonly A: LehrerRechtsverhaeltnis;
    static readonly N: LehrerRechtsverhaeltnis;
    static readonly W: LehrerRechtsverhaeltnis;
    static readonly U: LehrerRechtsverhaeltnis;
    static readonly B: LehrerRechtsverhaeltnis;
    static readonly J: LehrerRechtsverhaeltnis;
    static readonly S: LehrerRechtsverhaeltnis;
    static readonly X: LehrerRechtsverhaeltnis;
    static VERSION: number;
    readonly daten: LehrerKatalogRechtsverhaeltnisEintrag;
    readonly historie: Array<LehrerKatalogRechtsverhaeltnisEintrag>;
    private static readonly _rechtsverhaeltnisByID;
    private static readonly _rechtsverhaeltnisByKuerzel;
    /**
     * Erzeugt eine neue Art von Rechtsverhältnissen in der Aufzählung.
     *
     * @param historie   die Historie des Rechtsverhältnisses, welches ein Array von {@link LehrerKatalogRechtsverhaeltnisEintrag} ist
     */
    private constructor();
    /**
     * Gibt eine Map von den IDs der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     */
    private static getMapRechtsverhaeltnisByID;
    /**
     * Gibt eine Map von den Kürzeln der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     */
    private static getMapRechtsverhaeltnisByKuerzel;
    /**
     * Gibt die Art von Rechtsverhältnissen anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Art von Rechtsverhältnissen
     *
     * @return die Art von Rechtsverhältnissen oder null, falls die ID ungültig ist
     */
    static getByID(id: number): LehrerRechtsverhaeltnis | null;
    /**
     * Gibt die Art von Rechtsverhältnissen anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Art von Rechtsverhältnissen
     *
     * @return die Art von Rechtsverhältnissen oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel: String | null): LehrerRechtsverhaeltnis | null;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    private name;
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    private ordinal;
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString(): String;
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other: JavaObject): boolean;
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode(): number;
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other: LehrerRechtsverhaeltnis): number;
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values(): Array<LehrerRechtsverhaeltnis>;
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name: String): LehrerRechtsverhaeltnis | null;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_types_statkue_LehrerRechtsverhaeltnis(obj: unknown): LehrerRechtsverhaeltnis;
