"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerRechtsverhaeltnis = exports.LehrerRechtsverhaeltnis = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const LehrerKatalogRechtsverhaeltnisEintrag_1 = require("../../../core/data/lehrer/LehrerKatalogRechtsverhaeltnisEintrag");
const HashMap_1 = require("../../../java/util/HashMap");
class LehrerRechtsverhaeltnis extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static L = new LehrerRechtsverhaeltnis("L", 0, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(3, "L", "Beamter auf Lebenszeit", null, null)]);
    static P = new LehrerRechtsverhaeltnis("P", 1, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(2, "P", "Beamter auf Probe", null, null)]);
    static A = new LehrerRechtsverhaeltnis("A", 2, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(1, "A", "Beamter auf Probe zur Anstellung", null, null)]);
    static N = new LehrerRechtsverhaeltnis("N", 3, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(7, "N", "Beamter, nebenamtlich (nicht hauptamtlich im Schuldienst)", null, null)]);
    static W = new LehrerRechtsverhaeltnis("W", 4, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(9, "W", "Beamter auf Widerruf (LAA)", null, null)]);
    static U = new LehrerRechtsverhaeltnis("U", 5, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(4, "U", "Angestellte, unbefristet (BAT-Vertrag)", null, null)]);
    static B = new LehrerRechtsverhaeltnis("B", 6, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(5, "B", "Angestellte, befristet (BAT-Vertrag)", null, null)]);
    static J = new LehrerRechtsverhaeltnis("J", 7, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(6, "J", "Angestellte, nicht BAT-Vertrag", null, null)]);
    static S = new LehrerRechtsverhaeltnis("S", 8, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(8, "S", "Gestellungsvertrag", null, null)]);
    static X = new LehrerRechtsverhaeltnis("X", 9, [new LehrerKatalogRechtsverhaeltnisEintrag_1.LehrerKatalogRechtsverhaeltnisEintrag(10, "X", "Unentgeltlich Beschäftigte", null, null)]);
    static VERSION = 1;
    daten;
    historie;
    static _rechtsverhaeltnisByID = new HashMap_1.HashMap();
    static _rechtsverhaeltnisByKuerzel = new HashMap_1.HashMap();
    /**
     * Erzeugt eine neue Art von Rechtsverhältnissen in der Aufzählung.
     *
     * @param historie   die Historie des Rechtsverhältnisses, welches ein Array von {@link LehrerKatalogRechtsverhaeltnisEintrag} ist
     */
    constructor(name, ordinal, historie) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        LehrerRechtsverhaeltnis.all_values_by_ordinal.push(this);
        LehrerRechtsverhaeltnis.all_values_by_name.set(name, this);
        this.historie = historie;
        this.daten = historie[historie.length - 1];
    }
    /**
     * Gibt eine Map von den IDs der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den IDs der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     */
    static getMapRechtsverhaeltnisByID() {
        if (LehrerRechtsverhaeltnis._rechtsverhaeltnisByID.size() === 0)
            for (let l of LehrerRechtsverhaeltnis.values())
                LehrerRechtsverhaeltnis._rechtsverhaeltnisByID.put(l.daten.id, l);
        return LehrerRechtsverhaeltnis._rechtsverhaeltnisByID;
    }
    /**
     * Gibt eine Map von den Kürzeln der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     * zurück. Sollte diese noch nicht initialisiert sein, so wird sie initielisiert.
     *
     * @return die Map von den Kürzeln der Rechtsverhältnisse auf die zugehörigen Rechtsverhältnisse
     */
    static getMapRechtsverhaeltnisByKuerzel() {
        if (LehrerRechtsverhaeltnis._rechtsverhaeltnisByKuerzel.size() === 0)
            for (let l of LehrerRechtsverhaeltnis.values())
                LehrerRechtsverhaeltnis._rechtsverhaeltnisByKuerzel.put(l.daten.kuerzel, l);
        return LehrerRechtsverhaeltnis._rechtsverhaeltnisByKuerzel;
    }
    /**
     * Gibt die Art von Rechtsverhältnissen anhand der angegebenen ID zurück.
     *
     * @param id   die ID der Art von Rechtsverhältnissen
     *
     * @return die Art von Rechtsverhältnissen oder null, falls die ID ungültig ist
     */
    static getByID(id) {
        return LehrerRechtsverhaeltnis.getMapRechtsverhaeltnisByID().get(id);
    }
    /**
     * Gibt die Art von Rechtsverhältnissen anhand des angegebenen Kürzels zurück.
     *
     * @param kuerzel   das Kürzel der Art von Rechtsverhältnissen
     *
     * @return die Art von Rechtsverhältnissen oder null, falls das Kürzel ungültig ist
     */
    static getByKuerzel(kuerzel) {
        return LehrerRechtsverhaeltnis.getMapRechtsverhaeltnisByKuerzel().get(kuerzel);
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof LehrerRechtsverhaeltnis))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.types.statkue.LehrerRechtsverhaeltnis'].includes(name);
    }
}
exports.LehrerRechtsverhaeltnis = LehrerRechtsverhaeltnis;
function cast_de_nrw_schule_svws_core_types_statkue_LehrerRechtsverhaeltnis(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_types_statkue_LehrerRechtsverhaeltnis = cast_de_nrw_schule_svws_core_types_statkue_LehrerRechtsverhaeltnis;
//# sourceMappingURL=LehrerRechtsverhaeltnis.js.map