import { JavaObject } from '../../../java/lang/JavaObject';
import { GostStatistikFachwahl } from '../../../core/data/gost/GostStatistikFachwahl';
import { GostHalbjahr } from '../../../core/types/gost/GostHalbjahr';
export declare class GostStatistikFachwahlManager extends JavaObject {
    constructor();
    /**
     * Aktualisiert die Informationen zu einer Fachwahl in dem angegebenen Halbjahr anhand der übergebenen Fachwahl
     *
     * @param statfw     die Statistik-Informationen zu den Fachwahlen, bei denen die Informationen hinzugefügt werden sollen
     * @param halbjahr   das Halbjahr, zu der die Fachwahl gehört
     * @param fachwahl   die Fachwahl
     */
    static setFachwahlHalbjahr(statfw: GostStatistikFachwahl, halbjahr: GostHalbjahr, fachwahl: String | null): void;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_core_utils_gost_GostStatistikFachwahlManager(obj: unknown): GostStatistikFachwahlManager;
