"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_core_utils_gost_GostStatistikFachwahlManager = exports.GostStatistikFachwahlManager = void 0;
const JavaObject_1 = require("../../../java/lang/JavaObject");
const GostStatistikFachwahlHalbjahr_1 = require("../../../core/data/gost/GostStatistikFachwahlHalbjahr");
class GostStatistikFachwahlManager extends JavaObject_1.JavaObject {
    constructor() {
        super();
    }
    /**
     * Aktualisiert die Informationen zu einer Fachwahl in dem angegebenen Halbjahr anhand der übergebenen Fachwahl
     *
     * @param statfw     die Statistik-Informationen zu den Fachwahlen, bei denen die Informationen hinzugefügt werden sollen
     * @param halbjahr   das Halbjahr, zu der die Fachwahl gehört
     * @param fachwahl   die Fachwahl
     */
    static setFachwahlHalbjahr(statfw, halbjahr, fachwahl) {
        if (statfw.fachwahlen[halbjahr.id] === null)
            statfw.fachwahlen[halbjahr.id] = new GostStatistikFachwahlHalbjahr_1.GostStatistikFachwahlHalbjahr();
        if ((fachwahl === null) || !(JavaObject_1.JavaObject.equalsTranspiler("M", (fachwahl)) || JavaObject_1.JavaObject.equalsTranspiler("S", (fachwahl)) || JavaObject_1.JavaObject.equalsTranspiler("ZK", (fachwahl)) || JavaObject_1.JavaObject.equalsTranspiler("LK", (fachwahl))))
            return;
        statfw.fachwahlen[halbjahr.id].wahlenGKMuendlich += JavaObject_1.JavaObject.equalsTranspiler("M", (fachwahl)) ? 1 : 0;
        statfw.fachwahlen[halbjahr.id].wahlenGKSchriftlich += JavaObject_1.JavaObject.equalsTranspiler("S", (fachwahl)) ? 1 : 0;
        statfw.fachwahlen[halbjahr.id].wahlenGK += (JavaObject_1.JavaObject.equalsTranspiler("M", (fachwahl)) || JavaObject_1.JavaObject.equalsTranspiler("S", (fachwahl))) ? 1 : 0;
        statfw.fachwahlen[halbjahr.id].wahlenZK += JavaObject_1.JavaObject.equalsTranspiler("ZK", (fachwahl)) ? 1 : 0;
        statfw.fachwahlen[halbjahr.id].wahlenLK += JavaObject_1.JavaObject.equalsTranspiler("LK", (fachwahl)) ? 1 : 0;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.core.utils.gost.GostStatistikFachwahlManager'].includes(name);
    }
}
exports.GostStatistikFachwahlManager = GostStatistikFachwahlManager;
function cast_de_nrw_schule_svws_core_utils_gost_GostStatistikFachwahlManager(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_core_utils_gost_GostStatistikFachwahlManager = cast_de_nrw_schule_svws_core_utils_gost_GostStatistikFachwahlManager;
//# sourceMappingURL=GostStatistikFachwahlManager.js.map