import { JavaObject } from '../java/lang/JavaObject';
import { LogData } from '../logger/LogData';
import { Consumer } from '../java/util/function/Consumer';
export declare class LogConsumerConsole extends JavaObject implements Consumer<LogData> {
    readonly printTime: boolean;
    readonly printLevel: boolean;
    /**
     * Erzeugt einen neuen Consumer für Log-Informationen, mit den Standardeinstellungen,
     * das weder Zeit noch Log-Level mit ausgegeben werden.
     */
    constructor();
    /**
     * Erzeugt einen neuen Consumer für Log-Informationen.
     *
     * @param printTime     gibt an, ob die Zeit beim Loggen ausgegeben wird oder nicht
     * @param printLevel    gibt an, ob das Log-Level beim Loggen ausgegeben wird oder nicht
     */
    constructor(printTime: boolean, printLevel: boolean);
    /**
     * Diese Methode implementiert das funktionale Interface java.util.function.Consumer
     * und gibt die empfangenen Log-Informationen auf der Kommandozeile aus.
     *
     * @param t   die auszugebenden Log-Informationen
     */
    accept(t: LogData): void;
    isTranspiledInstanceOf(name: string): boolean;
}
export declare function cast_de_nrw_schule_svws_logger_LogConsumerConsole(obj: unknown): LogConsumerConsole;
