"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cast_de_nrw_schule_svws_logger_LogLevel = exports.LogLevel = void 0;
const JavaObject_1 = require("../java/lang/JavaObject");
class LogLevel extends JavaObject_1.JavaObject {
    /** the name of the enumeration value */
    __name;
    /** the ordinal value for the enumeration value */
    __ordinal;
    /** an array containing all values of this enumeration */
    static all_values_by_ordinal = [];
    /** an array containing all values of this enumeration indexed by their name*/
    static all_values_by_name = new Map();
    static APP = new LogLevel("APP", 0, 0);
    static ERROR = new LogLevel("ERROR", 1, 10);
    static WARNING = new LogLevel("WARNING", 2, 100);
    static INFO = new LogLevel("INFO", 3, 1000);
    static DEBUG = new LogLevel("DEBUG", 4, 10000);
    level;
    /**
     * Der von der Ausfzählung intern genutzte Konstruktor der Aufzählung
     *
     * @param level   der Integer-Wert des Log-Levels.
     */
    constructor(name, ordinal, level) {
        super();
        this.__name = name;
        this.__ordinal = ordinal;
        LogLevel.all_values_by_ordinal.push(this);
        LogLevel.all_values_by_name.set(name, this);
        this.level = level;
    }
    /**
     * Gibt den Integer-Wert des Log-Levels zurück.
     *
     * @return der Integer-Wert des Log-Levels
     */
    toInteger() {
        return this.level;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    name() {
        return this.__name;
    }
    /**
     * Returns the ordinal value of this enumeration value.
     *
     * @returns the ordinal value
     */
    ordinal() {
        return this.__ordinal;
    }
    /**
     * Returns the name of this enumeration value.
     *
     * @returns the name
     */
    toString() {
        return this.__name;
    }
    /**
     * Returns true if this and the other enumeration values are equal.
     *
     * @param other   the other enumeration value
     *
     * @returns true if they are equal and false otherwise
     */
    equals(other) {
        if (!(other instanceof LogLevel))
            return false;
        return this === other;
    }
    /**
     * Returns the ordinal value as hashcode, since the ordinal value is unique.
     *
     * @returns the ordinal value as hashcode
     */
    hashCode() {
        return this.__ordinal;
    }
    /**
     * Compares this enumeration value with the other enumeration value by their ordinal value.
     *
     * @param other   the other enumeration value
     *
     * @returns a negative, zero or postive value as this enumeration value is less than, equal to
     *          or greater than the other enumeration value
     */
    compareTo(other) {
        return this.__ordinal - other.__ordinal;
    }
    /**
     * Returns an array with enumeration values.
     *
     * @returns the array with enumeration values
     */
    static values() {
        return [...this.all_values_by_ordinal];
    }
    /**
     * Returns the enumeration value with the specified name.
     *
     * @param name   the name of the enumeration value
     *
     * @returns the enumeration values or null
     */
    static valueOf(name) {
        let tmp = this.all_values_by_name.get(name);
        return (!tmp) ? null : tmp;
    }
    isTranspiledInstanceOf(name) {
        return ['de.nrw.schule.svws.logger.LogLevel'].includes(name);
    }
}
exports.LogLevel = LogLevel;
function cast_de_nrw_schule_svws_logger_LogLevel(obj) {
    return obj;
}
exports.cast_de_nrw_schule_svws_logger_LogLevel = cast_de_nrw_schule_svws_logger_LogLevel;
//# sourceMappingURL=LogLevel.js.map